/****************************************************************************/
/* CINT.H - header & definition file for Sezam - C language interface       */
/* Last revision: 20. 2.1991                                                */
/****************************************************************************/
#ifndef CINT_INCLUDED
#define CINT_INCLUDED
#ifndef GENERAL_DEF
#include "defs.h"
#endif

#include "wbkernel.h"

extern int task_switch_enabled;
/******************************* internal services **************************/
extern "C" {
DllKernel int  WINAPI program_flags(cdp_t cdp, tptr src);

DllKernel BOOL FAR WINAPI Set_kernel_rtp(uns8 data);
DllKernel BOOL FAR WINAPI Lock_kernel    (void);
DllKernel void FAR WINAPI Unlock_kernel  (void);
DllKernel BOOL FAR WINAPI Unlock_user(BOOL objects);
DllKernel BOOL FAR WINAPI Get_users(uns16 maxusers, tobjnum FAR* userbuf);
DllKernel BOOL FAR WINAPI Kill_user(uns16 usernum);
DllKernel BOOL FAR WINAPI Remove_lock(lockinfo FAR* llock);
DllKernel BOOL FAR WINAPI Get_locks(uns16 maxlocks, lockinfo FAR* lockbuf);
DllKernel BOOL FAR WINAPI cd_List_objects(cdp_t cdp, tcateg category,
                  const uns8 * appl_id, tptr * buffer);
DllKernel BOOL FAR WINAPI cd_Db_copy(cdp_t cdp, ttablenum t1, trecnum r1, tattrib a1, uns16 ind1,
             ttablenum t2, trecnum r2, tattrib a2, uns16 ind2);
DllKernel BOOL  FAR WINAPI cd_Monitor(cdp_t cdp, t_monitor * mon);
DllKernel BOOL WINAPI PtrSteps(tcursnum cursor, trecnum   position, tattrib attr,
                            uns16 index, void FAR * buffer);
DllKernel BOOL FAR WINAPI Delete_history(ttablenum tb, BOOL datim_type, timestamp dtm);
DllKernel BOOL FAR WINAPI Recstate(tcursnum cursor, trecnum rec, uns8 FAR * state);
DllKernel BOOL FAR WINAPI Table_stat(ttablenum table, trecnum FAR * stat);
DllKernel BOOL FAR WINAPI Add_value(tcursnum cursor, trecnum position, tattrib attr, void FAR * buf, uns16 datasize);
DllKernel BOOL FAR WINAPI Del_value(tcursnum cursor, trecnum position, tattrib attr, void FAR * buf, uns16 datasize);
DllKernel BOOL FAR WINAPI Remove_invalid(tcursnum cursor, trecnum position, tattrib attr);
DllKernel BOOL FAR WINAPI xSave_table   (ttablenum table, HANDLE hFile);
DllKernel BOOL FAR WINAPI xRestore_table(ttablenum table, HANDLE hFile);
DllKernel BOOL WINAPI Get_valid_recs(tcursnum cursnum, trecnum startrec,
    trecnum limit, void FAR* map, trecnum FAR* totrec, trecnum FAR* valrec);
DllKernel BOOL FAR WINAPI Text_substring(tcursnum cursor, trecnum position, tattrib attr, uns16 index,
   tptr pattern, uns16 pattlen, uns32 start, uns16 flags, uns32 FAR * stringpos);
DllKernel BOOL FAR WINAPI Get_descriptor(tobjnum curs, tcateg cat, d_table ** td);
DllKernel BOOL FAR WINAPI cd_Get_descriptor(cdp_t cdp, tobjnum curs, tcateg cat, d_table ** td);
DllKernel BOOL WINAPI cd_Apl_id2name(cdp_t cdp, const uns8 * appl_id, char * name);
DllKernel BOOL WINAPI cd_Apl_name2id(cdp_t cdp, const char * name, uns8 * appl_id);
DllKernel BOOL FAR WINAPI Bck_replay(uns16 bad_user, timestamp dttm, uns32 FAR* stat);
DllKernel BOOL FAR WINAPI Bck_get_time(timestamp FAR* dttm);
DllKernel BOOL FAR WINAPI cd_Send_params(cdp_t cdp, uns32 stmt, DWORD len, void * value);
DllKernel BOOL FAR WINAPI cd_Send_parameter(cdp_t cdp, uns32 stmt, sig16 parnum, DWORD len, DWORD offset, void * value);
DllKernel BOOL WINAPI cd_Pull_params(cdp_t cdp, uns32 handle, sig16 code, void ** answer);
DllKernel BOOL FAR WINAPI Get_error_info(uns16 * line, uns16 * column, tptr buf);
DllKernel BOOL WINAPI cd_Get_error_info(cdp_t cdp, uns16 * line, uns16 * column, tptr buf);
DllKernel BOOL WINAPI cd_SQL_catalog(cdp_t cdp, BOOL metadata, unsigned ctlg_type,
                             unsigned parsize, tptr inpars, uns32 * result);
DllKernel BOOL WINAPI Server_access(char * buf);
DllKernel BOOL  FAR WINAPI Cursor_quality(tcursnum curs, trecnum * recnum, trecnum * falsecond, trecnum * truecond);
DllKernel BOOL  FAR WINAPI Back_count     (uns32 * count);
DllKernel BOOL  FAR WINAPI cd_Get_base_tables(cdp_t cdp, tcursnum curs, uns16 * cnt, ttablenum * tabs);
DllKernel BOOL WINAPI BrowseStart(HWND hServTree);
DllKernel void WINAPI BrowseStop(HWND hServTree);
DllKernel HWND WINAPI FindServerWindow(const char * server_name);
DllKernel BOOL WINAPI cd_GetSet_security(cdp_t cdp, t_oper operation, t_security * sec);

DllKernel BOOL WINAPI cd_Export_user(cdp_t cdp, tobjnum userobj, HANDLE hFile);
DllKernel BOOL WINAPI cd_Import_user(cdp_t cdp, HANDLE hFile);
DllKernel BOOL WINAPI SQL_get_result_set_info(uns32 handle, unsigned rs_order, d_table ** td);
DllKernel BOOL WINAPI SQL_get_param_info(uns32 handle, void ** pars);
DllKernel BOOL WINAPI cd_SQL_get_result_set_info(cdp_t cdp, uns32 handle, unsigned rs_order, d_table ** td);
DllKernel BOOL WINAPI cd_SQL_get_param_info(cdp_t cdp, uns32 handle, void ** pars);
DllKernel BOOL WINAPI cd_CD_ROM(cdp_t cdp);
DllKernel BOOL WINAPI cd_Enable_refint(cdp_t cdp, BOOL enable);
DllKernel BOOL WINAPI cd_Clear_passwords(cdp_t cdp);
DllKernel int  WINAPI tcpip_echo(char * server_name);
DllKernel BOOL WINAPI cd_Server_debug(cdp_t cdp, int oper, tobjnum objnum, int line, int * state, tobjnum * pobjnum, int * pline);
DllKernel BOOL WINAPI cd_Server_eval(cdp_t cdp, int frame, const char * expr, void * value);
DllKernel BOOL WINAPI cd_Server_stack(cdp_t cdp, t_stack_info ** value);
DllKernel BOOL WINAPI cd_Server_assign(cdp_t cdp, int frame, const char * dest, const char * value);
DllExport BOOL WINAPI erase_replica(cdp_t cdp);
DllKernel BOOL WINAPI cd_Server_log(cdp_t cdp, tptr * log);
void scan_objects(cdp_t cdp, tcateg cat, BOOL extended);
DllKernel BOOL WINAPI cd_Trigger_changed(cdp_t cdp, tobjnum trigobj);
DllKernel BOOL WINAPI cd_Procedure_changed(cdp_t cdp);
struct t_trig_info
{ uns32 trigger_type;
  tobjname name;
};
DllKernel BOOL WINAPI cd_List_triggers(cdp_t cdp, ttablenum tb, t_trig_info ** trgs);
typedef void CALLBACK t_client_error_callback(const char * text);
DllKernel void WINAPI set_client_error_callback(t_client_error_callback * client_error_callbackIn);
DllKernel void WINAPI client_error(cdp_t cdp, int num);
DllKernel void client_error_param(cdp_t cdp, int num, ...);

///////////////////////// functions from other modules //////////////////////
#define SEARCH_CASE_SENSITIVE   1
#define SEARCH_WHOLE_WORDS      2
#define SEARCH_BACKWARDS        4
#define SEARCH_IN_BLOCK         0x100
#define SEARCH_FROM_CURSOR      0x200
#define SEARCH_AUTOREPEAT       0x400
#define SEARCH_DOREPLACE        0x4000
#define SEARCH_NOCONT           0x8000
DllKernel BOOL FAR WINAPI Search_in_block(const char FAR * block, uns32 blocksize,
                         const char FAR * next, const char FAR * patt, uns16 pattsize,
                         uns16 flags, uns32 FAR * respos);
DllKernel void  FAR WINAPI wininichange(char * section);
/******************************** odbc ***************************************/

typedef struct // valid from version 5.0
{ unsigned version;
  char   start_name[OBJ_NAME_LEN+1];
  tcateg start_categ;
  char   dest_dsn[SQL_MAX_DSN_LENGTH+1];
  WBUUID dp_uuid; // must be cleared when imported
  WBUUID os_uuid;
  WBUUID vs_uuid;
 // new in version 6.0
  int      sel_language;
  tobjname front_end_name; // "" iff not redirected
  tobjname back_end_name;  // "" iff not redirected
  BOOL     appl_locked;
} apx_header;

#ifdef WINS
DllKernel BOOL FAR WINAPI Unlink_odbc_table(cdp_t cdp, ttablenum tb);
DllKernel void WINAPI odbc_stmt_error(cdp_t cdp, HSTMT hStmt);
DllKernel void WINAPI odbc_dbc_error(cdp_t cdp, HDBC hDbc);
DllKernel void WINAPI odbc_env_error(cdp_t cdp);
DllKernel t_connection * WINAPI connect_data_source(cdp_t cdp,
  const char * dsn, BOOL use_old_access, BOOL temporary);
DllKernel t_connection * WINAPI find_data_source(cdp_t cdp, const char * dsn);
DllKernel ltable * WINAPI get_ltable(cdp_t cdp, tcursnum tabnum);
DllKernel unsigned WINAPI get_object_flags(cdp_t cdp, tcateg category, ctptr name);
DllKernel BOOL WINAPI comp_dynar_search(t_dynar * d_comp, ctptr name, unsigned * pos);
DllKernel t_dynar * WINAPI get_object_cache(cdp_t cdp, tcateg category);
DllKernel tobjnum WINAPI object_to_cache(cdp_t cdp, t_dynar * d_comp,
   tcateg cat, ctptr name, tobjnum objnum, uns16 flags, unsigned * cache_index = NULL);
void sort_comp_dynar(t_dynar * d_comp);
DllKernel d_table * WINAPI make_odbc_descriptor(t_connection * conn, t_odbc_link * odbc_link, BOOL WB_types);
DllKernel ltable * WINAPI create_cached_access(cdp_t cdp, t_connection * conn,
                   tptr source, BOOL source_is_table, tcursnum cursnum);
DllKernel tcursnum WINAPI get_new_odbc_tabnum(cdp_t cdp);
DllKernel odbc_tabcurs * WINAPI get_odbc_tc(cdp_t cdp, tcursnum curs);
DllKernel tptr WINAPI srch(tptr source, tptr patt);
DllKernel void WINAPI merge_condition(tptr dest, tptr source, tptr cond);
DllKernel int  WINAPI odbc_delete_all(cdp_t cdp, HSTMT hStmt, tptr select_st);
DllKernel void WINAPI free_connection(cdp_t cdp, t_connection * conn);
DllKernel void WINAPI remove_temp_conns(cdp_t cdp);

DllKernel tptr WINAPI odbc_table_to_source(table_all * ta, BOOL altering, t_connection * conn);
DllKernel BOOL WINAPI map_tables(cdp_t cdp, t_connection * conn);
DllKernel void WINAPI start_mapping(cdp_t cdp);
DllKernel void WINAPI make_apl_query(char * query, const char * tabname, const uns8 * uuid);
d_table * make_result_descriptor(ltable * ltab);

#endif /* WINS */

 }      /* of extern "C" */

void cd_unlink_kernel(cdp_t cdp);

#endif


