///////////////////////////////////////// konfiguration: /////////////////////////////////////////
#ifdef WINS
#ifndef ODBCDRV
#define CLIENT_GUI   // object name cache, object def cache, help file, 
#define CLIENT_PGM   // emb. vars, languages
#define CLIENT_ODBC  // ODBC client
#endif
#else // !WINS
#define CLIENT_PGM  // allows to access embedded variables from SQL statements in WBC connectors
#endif

/////////////////////////// declarations common for client and server ////////////////////////////
#include "wbdefs.h"

////////////////////////////// client-specific global declarations: //////////////////////////////
#ifdef WINS
#define READ_WRITE OF_READWRITE
#define WRITE      OF_WRITE
#define READ       OF_READ
#endif

#define SEEK_SET        0         /* seek from start of file      */
#define SEEK_CUR        1       /* relative to current position */
#define SEEK_END        2       /* relative to end of file      */

#define EXX_CODE_VERSION (610*10+0)
#define PLATFORM_WINS     0
#define PLATFORM_NETWARE  1
#define PLATFORM_UNIX     2
#ifdef WINS
#define CURRENT_PLATFORM  PLATFORM_WINS
#else
#ifdef NETWARE
#define CURRENT_PLATFORM  PLATFORM_NETWARE
#else
#define CURRENT_PLATFORM  PLATFORM_UNIX
#endif
#endif
/******************************** kontexts **********************************/
#define CATEG_RECCUR     28
#define CATEG_D_TABLE    30
#define CATEG_TABLE_ALL  31

typedef struct kont_descr
{ struct    kont_descr * next_kont;
  tcateg    kontcateg;  /* CATEG_TABLE, CATEG_CURSOR, CATEG_DIRCUR, CATEG_RECCUR, etc. */
  tobjnum   kontobj;    /* table or cursor object number or open cursor */
  char      tabname[OBJ_NAME_LEN+1];    /* used only by SELECT compilation */
  char      schemaname[OBJ_NAME_LEN+1]; /* used only by SELECT compilation */
  void    * record_tobj;
} kont_descr;

CFNC DllKernel tptr WINAPI cd_Load_objdef(cdp_t cdp, tobjnum objnum, tcateg category, uns16 *pFlags = NULL);
CFNC DllKernel BOOL WINAPI cd_Load_prefix(cdp_t cdp, tobjnum objnum, tptr descr);
CFNC DllKernel void WINAPI enc_buffer_total(cdp_t cdp, tptr buf, int size, tobjnum objnum);
CFNC DllKernel BOOL WINAPI enc_copy_to_file(cdp_t cdp, ttablenum tb, trecnum recnum, tattrib attr,
                           uns16 index, HANDLE hFile, const char * objname);
CFNC DllKernel tptr WINAPI enc_read_from_file(cdp_t cdp, HANDLE hFile, WBUUID uuid, const char * objname, int * objsize);
#define ENCRYPTED_CATEG(cat) ((cat)==CATEG_TABLE || (cat)==CATEG_VIEW || (cat)==CATEG_CURSOR ||\
  (cat)==CATEG_MENU || (cat)==CATEG_PGMSRC || (cat)==CATEG_WWW || \
  (cat)==CATEG_DRAWING || (cat)==CATEG_REPLREL || \
  (cat)==CATEG_PROC || (cat)==CATEG_TRIGGER)

typedef struct
{ uns8 astate;
  tptr newval;
  uns8 orig_type;
} atr_state;

extern "C" {
DllKernel void WINAPI d_table_cache_open(void);
DllKernel void WINAPI d_table_cache_close(void);
//DllKernel d_table * WINAPI get_table_d(tobjnum tb, tcateg cat);
DllKernel d_table * WINAPI cd_get_table_d(cdp_t cdp, tobjnum tb, tcateg cat);
DllKernel void WINAPI free_table_d(tobjnum tb, tcateg cat);
DllKernel BOOL WINAPI find_attr(cdp_t cdp, tobjnum tb, tcateg cat,
   const char * name1, const char * name2, const char * name3, d_attr * info);
DllKernel int  WINAPI first_user_attr(d_table * td);
DllKernel const char * WINAPI set_this_form_source(cdp_t cdp, const char * source);

}
void WINAPI destroy_cursor_table_d(cdp_t cdp);

#include "wbcdp.h"

#define MAX_MAX_TASKS (200+3)       // max connections from a client process (ISAPI needs many of them)
extern cdp_t cds[MAX_MAX_TASKS];   /* must not be based here */

#ifdef WINS
#define GetClientId GetCurrentThreadId   /* WIN32 */
#else
#ifdef UNIX
#define GetClientId pthread_self         /* UNIX */
#else
#define GetClientId GetThreadID          /* NLM */
#endif
#endif

extern answer_cb reject_answer;
void write_ans_proc(cd_t * cdp, answer_cb * ans);
extern HINSTANCE hKernelLibInst;
void status_text(unsigned txid);

BOOL total_free(uns8 tp);
unsigned get_client_memory(void);

// copies
#define STBR_IMPEXP      2002
#define FILTER_TDT          1813
#define EXT_DATE_FORMATS      6

void *operator new(unsigned size);
void operator delete(void * ptr);
void *operator new(unsigned size, CIp_t CI);
#ifdef WINS
void operator delete(void * ptr, CIp_t CI);
#endif

#define WB_COLOR_LTGRAY 0xc0c0c0
#define SYSCOLORPART(x) (((x)>>24)-1)
#define WBSYSCOLOR(x)   (((x)+1)<<24)
#define RGBCOLOR(x)     ((x) & 0xffffff)
#define DYNAMIC_COLOR   0x7f000000
#define DYNAMIC_SYSPART 0x7e

#include "rcdefs.h"
