#ifdef UNIX
#include <stdlib.h>
#endif

void free_cursor(tcursnum curs);  /* unregisters and deletes cursor */

void *operator new(unsigned size)
  { return corealloc(size, 97); }
void operator delete(void * ptr)
  { corefree(ptr); }
void *operator new[](unsigned size)
  { return corealloc(size, 197); }
void operator delete[](void * ptr)
  { corefree(ptr); }

void *operator new(unsigned size, CIp_t CI)
{ void * ptr = corealloc(size, 97); 
  if (ptr==NULL) c_error(OUT_OF_KERNEL_MEMORY);
  return ptr;
}
#ifdef WINS
void operator delete(void * ptr, CIp_t CI)
{ corefree(ptr); }
#endif

#ifndef SRVR
struct t_express
{ int dummy; };
#endif

/****************************** dynamic array *******************************/
#ifdef STOP
BOOL ind_descr::same(ind_descr * sec)
{ if (partnum!=sec->partnum || index_type!=sec->index_type) return FALSE;
  for (unsigned i=0;  i<partnum;  i++)
    if (part[i].desc!=sec->part[i].desc || part[i].size!=sec->part[i].size ||
        !same_expr(part[i].expr, sec->part[i].expr))
      return FALSE;
  return TRUE;
}

BOOL forkey_constr::same(forkey_constr * sec, index_dynar * indxs, index_dynar * indxs2)
{ if (update_rule!=sec->update_rule ||
      delete_rule!=sec->delete_rule) return FALSE;
  if (par_index_num!=sec->par_index_num) return FALSE;
  if (desttabnum!=sec->desttabnum) return FALSE;
  return indxs->acc(loc_index_num)->same(indxs2->acc(sec->loc_index_num));
}
#endif

BOOL index_dynar::delet(unsigned index)
{ if (index >= (unsigned)count()) return FALSE;
  acc(index)->ind_descr::~ind_descr();
  return t_dynar::delet(index);
}

index_dynar::~index_dynar(void)    /* t_dynar destructor called then */
{ for (int i=0;  i<count();  i++) acc(i)->ind_descr::~ind_descr(); }

BOOL check_dynar::delet(unsigned index)
{ if (index >= (unsigned)count()) return FALSE;
  acc(index)->check_constr::~check_constr();
  return t_dynar::delet(index);
}

check_dynar::~check_dynar(void)    /* t_dynar destructor called then */
{ for (int i=0;  i<count();  i++) acc(i)->check_constr::~check_constr(); }

BOOL refer_dynar::delet(unsigned index)
{ if (index >= (unsigned)count()) return FALSE;
  acc(index)->forkey_constr::~forkey_constr();
  return t_dynar::delet(index);
}

refer_dynar::~refer_dynar(void)    /* t_dynar destructor called then */
{ for (int i=0;  i<count();  i++) acc(i)->forkey_constr::~forkey_constr(); }

BOOL attr_dynar::delet(unsigned index)
{ if (index >= (unsigned)count()) return FALSE;
  acc(index)->atr_all::~atr_all();
  return t_dynar::delet(index);
}

attr_dynar::~attr_dynar(void)    /* t_dynar destructor called then */
{ for (int i=0;  i<count();  i++) acc(i)->atr_all::~atr_all(); }

ind_descr::~ind_descr(void)   /* destructor for reftables called automatically */
{ corefree(text);  text=NULL;
  for (int i=0;  i<partnum;  i++)
    delete part[i].expr;
}

check_constr::~check_constr(void)
{ delete text;  text=NULL;  delete expr;  expr=NULL; }


#ifdef WINS

#if !defined(__WIN32__)
#define     GlobalPtrHandle(lp)         \
                ((HGLOBAL)LOWORD(GlobalHandle(SELECTOROF(lp))))
#else
#define     GlobalPtrHandle(lp)         \
                ((HGLOBAL)GlobalHandle(lp))
#endif

#endif //WINS

unsigned glob_total = 0;

void * glob_alloc(uns32 size)
#ifdef WINS
{ HGLOBAL hnd;
  hnd=GlobalAlloc(GMEM_MOVEABLE, size);
  if (!hnd) return NULL;
  glob_total+=GlobalSize(hnd);
  return GlobalLock(hnd);
}
#else
{ return malloc(size); }
#endif

void glob_free(void * ptr)
#ifdef WINS
{ HGLOBAL hnd;
  if (ptr!=NULL)
  { hnd=GlobalPtrHandle(ptr);  
    glob_total-=GlobalSize(hnd);
    GlobalUnlock(hnd);  GlobalFree(hnd); 
  }
}
#else
{ free(ptr); }
#endif

void * glob_realloc(void * ptr0, uns32 newsize)
#ifdef WINS
{ uns32 oldsize;  HGLOBAL oldhnd, newhnd;  void * ptr1;
  if (ptr0==NULL) return glob_alloc(newsize);
  if (!newsize) { glob_free(ptr0);  return NULL; }
  newhnd=GlobalAlloc(GMEM_MOVEABLE, newsize);
  if (!newhnd) return NULL;
  ptr1=GlobalLock(newhnd);
  if (ptr1==NULL) { GlobalUnlock(newhnd);  return NULL; }
  oldhnd=GlobalPtrHandle(ptr0);
  oldsize=GlobalSize(oldhnd);
  memcpy(ptr1, ptr0, newsize > oldsize ? oldsize : newsize);
  GlobalUnlock(oldhnd);  GlobalFree(oldhnd);
  return ptr1;
}
#else
{ return corerealloc (ptr0, newsize); }
#endif

