/****************************************************************************/
/* wbapiex.h - definice pro rozsirenou komunikaci s WinBase602              */
/* (C) Janus Drozd, 1992, 93, 94, 95, 96, 97, 98, 99                        */
/* verze: 6.0 (32-bit)                                                      */
/****************************************************************************/
#ifndef __WBAPIEX_H__
#define __WBAPIEX_H__


extern "C" {

// Memory management:
DllKernel BOOL   WINAPI core_init(int num);
DllKernel void   WINAPI core_release(void);
DllKernel void   WINAPI corefree(const void * x);
DllKernel void * WINAPI corealloc(unsigned x, uns8 owner);

// object flags:
#define CO_FLAG_ODBC           1
#define CO_FLAG_LINK           0x80
#define CO_FLAG_REPLTAB        2
#define CO_FLAG_SIMPLE_VW      1
#define CO_FLAG_GRAPH_VW       2
#define CO_FLAG_LABEL_VW       3
#define CO_FLAG_REPORT_VW      4
#define CO_FLAG_POPUP_MN       1
#define CO_FLAG_INCLUDE        1
#define CO_FLAG_SQL            2
#define CO_FLAG_TRANSPORT      3
#define CO_FLAG_REF12          1
#define CO_FLAG_REF21          2
#define CO_FLAG_WWWCONN        1
#define CO_FLAG_WWWSEL         2
#define CO_FLAG_PROTECT        0x20
#define CO_FLAG_ENCRYPTED      0x100
#define CO_FLAG_NOEXPORT       0x40
#define CO_FLAG_NOEXPORTD      0x10

#define CO_FLAGS_OBJECT_TYPE   7

// object descriptor:
#define OBJECT_DESCRIPTOR_SIZE 46
DllKernel void WINAPI make_object_descriptor(char * buf, const char * folder_name);
DllKernel BOOL WINAPI get_object_descriptor_data(const char * buf, tobjname folder_name, uns32 * stamp);

typedef short t_folder_index;

// conversion routines:
DllKernel tptr WINAPI cutspaces(tptr txt);
DllKernel void WINAPI int2str  (sig32 val, tptr txt);
DllKernel BOOL WINAPI str2int  (tptr txt, sig32 * val);
DllKernel BOOL WINAPI str2real (tptr txt, double * val);
DllKernel void WINAPI real2str (double val, tptr txt, short param);
DllKernel void WINAPI money2str(monstr * val, tptr txt, short param);
DllKernel BOOL WINAPI str2money(tptr txt, monstr * val);
DllKernel void WINAPI int2money(sig32 i, monstr * m);
DllKernel void WINAPI money2int(monstr * m, sig32 * i);
DllKernel void WINAPI datim2str(uns32 dtm, tptr txt, short param);
}

#endif // __WBAPIEX_H__

