/****************************************************************************/
/* nwclient.cpp - client NLM WB serveru v NLM                               */
/****************************************************************************/
#include "winrepl.h"

#include "defs.h"
#include "comp.h"
#include "cint.h"
// #include "wprez.h"
#include <signal.h>
#include <stdio.h>
#include <unistd.h>

#define PT_DIRECT 0x80
void core_release(void);
#include "dynar.cpp"

char wbHdr[]      = "\nWinBase 602 Client - Novell & Unix\n";
char storedOK[]   = "\nWinBase 602 Client - stop.\n";
char napoveda[]   = \
"\nwbcl [-v -dn -dt -dd -dr -dl<n> -dm<n> -s<> -l<> -p<> -a<>]\n\
-v  verbose                      -s<server_name>\n\
-dn display attr. name           -l<login_name>\n\
-dt               type           -p<password>\n\
-dd               description    -a<application|_name>\n\
-dr         record number \n\
-dl<n> display <n> bytes of text attr. ( 0 - only descr.)\n\
-dm<n> display mode : 0 - one record per page\n\
                      1 - all records and one record per line\n";

cd_t my_cd;  
cdp_t cdp = &my_cd;
BOOL connected = FALSE; 

#pragma off(unreferenced)

void TermAbortProc(int sig)
{ if (connected)
    { cd_interf_close(cdp);  connected=FALSE; 
      printf("Term | Abort Signal");
    }
  core_release();
}

void write_error_info(const char * caller)
{ int err=cd_Sz_error(cdp);
  if (err) printf("\nChyba cislo %d v %s.", err, caller);
}

CFNC int WINAPI Signalize(void)
{ write_error_info("nespecifikovanem modulu"); 
  return cd_Sz_error(cdp);
}

CFNC void WINAPI no_memory(void)
{ printf("\nNeni dost pameti."); }

CFNC tptr WINAPI sigalloc(unsigned size, uns8 owner)
{ tptr p=(tptr) corealloc(size, owner);
  if (p==NULL) no_memory();
  return p;
}

/*
CFNC void WINAPI client_error(cdp_t cdp, int num)
{ cdp->RV.report_number=num;  
  cdp->last_error_is_from_client=wbtrue; 
}
*/

// globalni promene :
BOOL disp_attrname;  //zobrazuj jmena atributu
BOOL disp_attrtype;  //zobrazuj typ atributu
char disp_recsep[8]; //record separator
char disp_attrsep[8];//attr separator
BOOL disp_recnum;    //zobrazuj cislo zaznamu pred kazdym zaznamem
tattrib attr_count;  //kolikaty atribut zobrazuju
tcurstab cursor_num; //cislo prave otevreneho kurzoru
trecnum rec_num;     //kolikaty zaznam zobrazuju
BOOL verbose;        //ukecany mod
BOOL disp_descr;     //zobrazuj popis u nezobrazitelnych atributu
int disp_textl;      //zobrazuj n bytes textoveho atributu, max 64kb
int disp_mode;       //mod zobrazeni : 0 jeden zaznam, jeden atribut na radku
                     //                1 jeden zaznam na jeden radek
BOOL use_wbcl;       //pouzij i parametry z wbcl.conf, z prik.radky maji prednost

BOOL Disp_Attr0( char * attrname, uns8 attrtype, uns8 attrmult, uns16 attrspecif)
{ // vypis cursoru v mode 0
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (disp_attrname)
    {
      printf("%s ", attrname);
      for (int i=0; 32-i>strlen(attrname); i++)
        printf(" ");
    }
    if (attrtype==ATT_INT32)
    {  
      int attr_int;
      if (disp_attrtype)
        printf("Integer   ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_int))
        if (attr_int != NONEINTEGER)    
          printf("%d", attr_int);
    }
    else if (attrtype==ATT_INT16)
    {
      sig16 attr_short;
      if (disp_attrtype)
        printf("Short     ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_short))
        if (attr_short != NONESHORT)
	  printf("%d", attr_short);
    }
    else if (attrtype==ATT_BOOLEAN)
    {
      uns8 attr_bool;
      if (disp_attrtype)
        printf("Bool      ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_bool))
        if (attr_bool != NONEBOOLEAN)
	  if (attr_bool == TRUE)
            printf("TRUE");
	  else
            printf("FALSE");
    }
    else if (attrtype==ATT_CHAR)
    {
      char attr_char;
      if (disp_attrtype)
        printf("Char      ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_char))
        if (attr_char != NONECHAR)
	{
	  printf("%c", attr_char);
	  if (disp_descr)
	    printf(",[%d]", attr_char);
	}
    }
    else if (attrtype==ATT_FLOAT)
    {
      float attr_real;
      if (disp_attrtype)
        printf("Real      ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_real))
        if (attr_real != NONEREAL)
	  printf("%f", attr_real);
    }
    else if (attrtype==ATT_STRING || attrtype==ATT_CSSTRING || attrtype==ATT_CSISTRING)
    {
      char attr_str[256];
      if (disp_attrtype)
      {
        if (attrtype==ATT_STRING)
          printf("String    ");
        else if (attrtype==ATT_CSSTRING)
          printf("CSString  ");
        else if (attrtype==ATT_CSISTRING)
          printf("CSIString ");
      }
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, attr_str))
        if (*attr_str != 0)
	  printf("%s", attr_str);
    }
    else if (attrtype==ATT_TEXT)
    {
      char attr_text[65536];
      uns32 datasize;
      if (disp_attrtype)
        printf("Text      ");
      uns32 attr_len;
      if (disp_descr)
        if (!Read_len( cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	    printf("%d bytes", attr_len);
      if (disp_textl > 65536)
        disp_textl = 65536;
      if (attr_len > 0 && disp_textl > 0)
        if (!Read_var( cursor_num, rec_num, attr_count, NOINDEX, 0, disp_textl, attr_text, &datasize))
          if (datasize > 0)
	  {
	    if (attr_len > disp_textl-1) attr_text[disp_textl-1]=0;
	    printf("\n%s", attr_text);
	  }
    }
    else if (attrtype==ATT_MONEY)
    {
      monstr attr_money;
      if (disp_attrtype)
        printf("Money     ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_money))
        if (money2real(&attr_money)!=NULLREAL)
	  printf("%.2f", money2real(&attr_money));
    }
    else if (attrtype==ATT_DATE)
    {
      uns32 attr_date;
      if (disp_attrtype)
        printf("Date      ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_date))
        if (attr_date != NONEDATE)
	  printf("%d.%d.%d", Day(attr_date), Month(attr_date), Year(attr_date));
    }
    else if (attrtype==ATT_TIME)
    {
      uns32 attr_time;
      if (disp_attrtype)
        printf("Time      ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_time))
        if (attr_time != NONETIME)
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
    }
    else if (attrtype==ATT_TIMESTAMP)
    {
      uns32 attr_ts;
      uns32 attr_time;
      uns32 attr_date;
      if (disp_attrtype)
        printf("Timestamp ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_ts))
        if (attr_ts != NONETIME)
	{
	  attr_date = timestamp2date(attr_ts);
	  attr_time = timestamp2time(attr_ts);
	  printf("%d.%d.%d - ", Day(attr_date), Month(attr_date), Year(attr_date));
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
	}
    }
    else if (attrtype==ATT_BINARY)
    {
      uns8 attr_bin[256];
      uns16 attr_binl;
      tattrib attrnum;
      uns8 attrtype;
      uns8 attrmult;
      if (disp_attrtype)
        printf("Binary    ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, attr_bin))
        if (Attribute_info(cursor_num, attrname, &attrnum, &attrtype, &attrmult, &attr_binl))
	{
	  if (attr_binl>16) 
	    attr_binl=16;
	  for (int i=0; i<attr_binl; i++)
	    printf("%.2X", attr_bin[i]);
	}
    }
    else if (attrtype==ATT_RASTER)
    {
      if (disp_attrtype)
        printf("Raster    ");
      uns32 attr_len;
      if (disp_descr)
        if (!Read_len( cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%d bytes", attr_len);
    }
    else if (attrtype==ATT_NOSPEC)
    {
      if (disp_attrtype)
        printf("Nospec    ");
      uns32 attr_len;
      if (disp_descr)
        if (!Read_len( cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%d bytes", attr_len);
    }
/* vzor pro dlsi typy
    else if (attrtype==ATT_)
    {
       attr_;
      if (disp_attrtype)
        printf(" ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_))
        if (attr_ != NONE)
	  printf("%d", attr_);
    }
    */
    printf("\n");
  }
  return TRUE;
}

BOOL Disp_Attr1( char * attrname, uns8 attrtype, uns8 attrmult, uns16 attrspecif)
{ // vypis dat z cursoru v mode 1
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (attrtype==ATT_INT32)
    {  
      int attr_int;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_int))
        if (attr_int != NONEINTEGER)    
          printf("%d", attr_int);
    }
    else if (attrtype==ATT_INT16)
    {
      sig16 attr_short;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_short))
        if (attr_short != NONESHORT)
	  printf("%d", attr_short);
    }
    else if (attrtype==ATT_BOOLEAN)
    {
      uns8 attr_bool;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_bool))
        if (attr_bool != NONEBOOLEAN)
	  if (attr_bool == TRUE)
            printf("TRUE");
	  else
            printf("FALSE");
    }
    else if (attrtype==ATT_CHAR)
    {
      char attr_char;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_char))
        if (attr_char != NONECHAR)
	{
	  printf("%c", attr_char);
	  if (disp_descr)
	    printf(",[%d]", attr_char);
	}
    }
    else if (attrtype==ATT_FLOAT)
    {
      float attr_real;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_real))
        if (attr_real != NONEREAL)
	  printf("%f", attr_real);
    }
    else if (attrtype==ATT_STRING || attrtype==ATT_CSSTRING || attrtype==ATT_CSISTRING)
    {
      char attr_str[256];
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, attr_str))
        if (*attr_str != 0)
	  printf("%s", attr_str);
    }
    else if (attrtype==ATT_TEXT)
    {
      char attr_text[65536];
      uns32 datasize;
      uns32 attr_len;
      if (disp_descr)
        if (!Read_len( cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	    printf("%d bytes", attr_len);
      if (disp_textl > 65536)
        disp_textl = 65536;
      if (attr_len > 0 && disp_textl > 0)
        if (!Read_var( cursor_num, rec_num, attr_count, NOINDEX, 0, disp_textl, attr_text, &datasize))
          if (datasize > 0)
	  {
	    if (attr_len > disp_textl-1) attr_text[disp_textl-1]=0;
	    printf("%s", attr_text);
	  }
    }
    else if (attrtype==ATT_MONEY)
    {
      monstr attr_money;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_money))
        if (money2real(&attr_money)!=NULLREAL)
	  printf("%.2f", money2real(&attr_money));
    }
    else if (attrtype==ATT_DATE)
    {
      uns32 attr_date;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_date))
        if (attr_date != NONEDATE)
	  printf("%d.%d.%d", Day(attr_date), Month(attr_date), Year(attr_date));
    }
    else if (attrtype==ATT_TIME)
    {
      uns32 attr_time;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_time))
        if (attr_time != NONETIME)
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
    }
    else if (attrtype==ATT_TIMESTAMP)
    {
      uns32 attr_ts;
      uns32 attr_time;
      uns32 attr_date;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_ts))
        if (attr_ts != NONETIME)
	{
	  attr_date = timestamp2date(attr_ts);
	  attr_time = timestamp2time(attr_ts);
	  printf("%d.%d.%d - ", Day(attr_date), Month(attr_date), Year(attr_date));
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
	}
    }
    else if (attrtype==ATT_BINARY)
    {
      uns8 attr_bin[256];
      uns16 attr_binl;
      tattrib attrnum;
      uns8 attrtype;
      uns8 attrmult;
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, attr_bin))
        if (Attribute_info(cursor_num, attrname, &attrnum, &attrtype, &attrmult, &attr_binl))
	{
	  if (attr_binl>16) 
	    attr_binl=16;
	  for (int i=0; i<attr_binl; i++)
	    printf("%.2X", attr_bin[i]);
	}
    }
    else if (attrtype==ATT_RASTER)
    {
      uns32 attr_len;
      if (disp_descr)
        if (!Read_len( cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%d bytes", attr_len);
    }
    else if (attrtype==ATT_NOSPEC)
    {
      uns32 attr_len;
      if (disp_descr)
        if (!Read_len( cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%d bytes", attr_len);
    }
/* vzor pro dlsi typy
    else if (attrtype==ATT_)
    {
       attr_;
      if (disp_attrtype)
        printf(" ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_))
        if (attr_ != NONE)
	  printf("%d", attr_);
    }
    */
    printf(", ");
  }
  return TRUE;
}

BOOL Disp_Attrname1( char * attrname, uns8 attrtype, uns8 attrmult, uns16 attrspecif)
{ // vypis jmen atributu v cursoru v mode 1
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (disp_attrname)
    {
      printf("%s ", attrname);
//      for (int i=0; 32-i>strlen(attrname); i++)
//        printf(" ");
    }
    printf(", ");
  }
  return TRUE;
}

BOOL Disp_Attrtype1( char * attrname, uns8 attrtype, uns8 attrmult, uns16 attrspecif)
{ // vypis typu atributu v cursoru v mode 1
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (attrtype==ATT_INT32)
    {  
      if (disp_attrtype)
        printf("Integer");
    }
    else if (attrtype==ATT_INT16)
    {
      if (disp_attrtype)
        printf("Short");
    }
    else if (attrtype==ATT_BOOLEAN)
    {
      if (disp_attrtype)
        printf("Bool");
    }
    else if (attrtype==ATT_CHAR)
    {
      if (disp_attrtype)
        printf("Char");
    }
    else if (attrtype==ATT_FLOAT)
    {
      if (disp_attrtype)
        printf("Real");
    }
    else if (attrtype==ATT_STRING || attrtype==ATT_CSSTRING || attrtype==ATT_CSISTRING)
    {
      if (disp_attrtype)
      {
        if (attrtype==ATT_STRING)
          printf("String");
        else if (attrtype==ATT_CSSTRING)
          printf("CSString");
        else if (attrtype==ATT_CSISTRING)
          printf("CSIString");
      }
    }
    else if (attrtype==ATT_TEXT)
    {
      if (disp_attrtype)
        printf("Text");
    }
    else if (attrtype==ATT_MONEY)
    {
      if (disp_attrtype)
        printf("Money");
    }
    else if (attrtype==ATT_DATE)
    {
      if (disp_attrtype)
        printf("Date");
    }
    else if (attrtype==ATT_TIME)
    {
      if (disp_attrtype)
        printf("Time");
    }
    else if (attrtype==ATT_TIMESTAMP)
    {
      if (disp_attrtype)
        printf("Timestamp");
    }
    else if (attrtype==ATT_BINARY)
    {
      if (disp_attrtype)
        printf("Binary");
    }
    else if (attrtype==ATT_RASTER)
    {
      if (disp_attrtype)
        printf("Raster");
    }
    else if (attrtype==ATT_NOSPEC)
    {
      if (disp_attrtype)
        printf("Nospec");
    }
/* vzor pro dlsi typy
    else if (attrtype==ATT_)
    {
       attr_;
      if (disp_attrtype)
        printf(" ");
      if (!Read_ind( cursor_num, rec_num, attr_count, NOINDEX, &attr_))
        if (attr_ != NONE)
	  printf("%d", attr_);
    }
    */
    printf(", ");
  }
  return TRUE;
}

void Display_Cursor( int cursor)
{
  if (verbose)
    printf("\nVystup dat z prikazu Select\n");
  cursor_num=cursor;
  rec_num=0;
  trecnum rec_all;
  Rec_cnt( cursor, &rec_all);
  if (((int)rec_all > 0) && (disp_mode == 0))
  {
    do
    {
      attr_count=0;
      if (disp_recnum)
        printf("zobrazuji zaznam %d z %d :\n", rec_num, rec_all);
      Enum_attributes( cursor, Disp_Attr0);
      rec_num++;
      if (verbose)
        printf("\nEnter - dalsi zaznam, q - konec \n");
    }
    while (((int)rec_num < (int)rec_all) && (getchar() != 'q'));
    getchar();
  }
  else if (((int)rec_all > 0) && (disp_mode == 1))
  {
    if (disp_attrname)
    {
      Enum_attributes( cursor, Disp_Attrname1);
      printf("\n");
    }
    if (disp_attrtype)  
    {
      Enum_attributes( cursor, Disp_Attrtype1);
      printf("\n");
    }
    do
    {
      attr_count=0;
      strcpy ( disp_attrsep, ", ");
      if (disp_recnum)
        printf("%d%s", rec_num, disp_attrsep);
      Enum_attributes( cursor, Disp_Attr1);
      rec_num++;
      printf("\n");
    }
    while ((int)rec_num < (int)rec_all);
  }
  Close_cursor(cursor);
  return;
}

BOOL Do_SQL(void)
{
  char SQLexecute[1024];
  uns32 result;
  if (verbose)
    printf("\nSQL prikaz nebo q (=quit): \n");
  if (fgets( SQLexecute, 1023, stdin)==NULL) 
    return FALSE;
  if (strncmp( SQLexecute, "q", 1)==0 && SQLexecute[2]==0)
    return FALSE;
  if (verbose)
    printf("\nZpracovavam SQL prikaz %s \n", SQLexecute);
  if (cd_SQL_execute(cdp, SQLexecute, &result)) 
    write_error_info("SQL_execute ");
  else 
    if ((result & 0xffff0000) == 0xffff0000) 
      Display_Cursor( result & 0x0000ffff);
    else 
      printf("pocet zpracovanych zaznamu : %d \n", result);
  return TRUE;
}


void main(int argc, char *argv[])
{ 

  char inicesta[MAX_PATH];
  char ParamName[50]; //sem se uklada jmeno hledaneho parametru
  char ServerName[50];
  char LoginName[50];
  char Password[50];
  char Application[50];
  char TmpStr[50];

  signal(SIGTERM, TermAbortProc);                                                        
  signal(SIGABRT, TermAbortProc);

  // nastaveni default hodnot (mizerne gcc to pri optimalizaci nevynuluje)
  inicesta[0]=0;
  ParamName[0]=0;
  ServerName[0]=0;
  LoginName[0]=0;
  Password[0]=0;
  Application[0]=0;
  disp_attrname=FALSE;
  disp_attrtype=FALSE;
  disp_recnum=FALSE;
  disp_descr=FALSE;
  verbose=FALSE;
  

  // jmeno sekce, kde budu hledat parametry dotazu
 #define CLIENTINI		"Client"
  
  //nalezeni spravne cesty ke config souboru
  if (access("/usr/local/etc/wbcl.conf",R_OK)==0)
     strcpy(inicesta,"/usr/local/etc/wbcl.conf");
  else if (access("/usr/etc/wbcl.conf",R_OK)==0)
         strcpy(inicesta,"/usr/etc/wbcl.conf");
  else if (access("/etc/wbcl.conf",R_OK)==0)
         strcpy(inicesta,"/etc/wbcl.conf");

  if ((inicesta[0]) != 0)
  {
    //cestu mam, jdu hledat parametry dotazu
    strcpy(ParamName,"ServerName");
    GetPrivateProfileString(CLIENTINI,ParamName,"",ServerName,50,inicesta);
    strcpy(ParamName,"LoginName");
    GetPrivateProfileString(CLIENTINI,ParamName,"",LoginName,50,inicesta);
    strcpy(ParamName,"Password");
    GetPrivateProfileString(CLIENTINI,ParamName,"",Password,50,inicesta);
    strcpy(ParamName,"Application");
    GetPrivateProfileString(CLIENTINI,ParamName,"",Application,50,inicesta);
    strcpy(ParamName,"Verbose");
    GetPrivateProfileString(CLIENTINI,ParamName,"",TmpStr,50,inicesta);
    if (strncasecmp(TmpStr,"true",4) == 0)
      verbose = TRUE;
    strcpy(ParamName,"DispAttrName");
    GetPrivateProfileString(CLIENTINI,ParamName,"",TmpStr,50,inicesta);
    if (strncasecmp(TmpStr,"true",4) == 0)
      disp_attrname = TRUE;
    strcpy(ParamName,"DispAttrType");
    GetPrivateProfileString(CLIENTINI,ParamName,"",TmpStr,50,inicesta);
    if (strncasecmp(TmpStr,"true",4) == 0)
      disp_attrtype = TRUE;
    strcpy(ParamName,"DispRecNum");
    GetPrivateProfileString(CLIENTINI,ParamName,"",TmpStr,50,inicesta);
    if (strncasecmp(TmpStr,"true",4) == 0)
      disp_recnum = TRUE;
    strcpy(ParamName,"DispDescr");
    GetPrivateProfileString(CLIENTINI,ParamName,"",TmpStr,50,inicesta);
    if (strncasecmp(TmpStr,"true",4) == 0)
      disp_descr = TRUE;
    strcpy(ParamName,"DispTextLen");
    disp_textl = GetPrivateProfileInt(CLIENTINI,ParamName,disp_textl,inicesta);
    strcpy(ParamName,"DispMode");
    disp_mode = GetPrivateProfileInt(CLIENTINI,ParamName,disp_mode,inicesta);
  };

  for (int i=1; i<argc; i++)
  {
    if (*(argv[i]) == '-')
    {
      switch (*(argv[i]+1))
      {
        case 'c':
          if (*(argv[i]+2) != '-')
            use_wbcl = TRUE;
	  else
            use_wbcl = FALSE;
          break;
        case 'v':
          if (*(argv[i]+2) != '-')
            verbose = TRUE;
	  else
            verbose = FALSE;
          break;
        case 's':
          if ((argv[i]+2) != 0)
            strcpy((argv[i]+2), ServerName);
          else
          {
            i++;
	    if (i<argc)
              strcpy((argv[i]), ServerName);
          }
          break;
        case 'l':
          if ((argv[i]+2) != 0)
            strcpy((argv[i]+2), LoginName);
          else
          {
            i++;
	    if (i<argc)
              strcpy((argv[i]), LoginName);
          }
          break;
        case 'p':
          if ((argv[i]+2) != 0)
            strcpy((argv[i]+2), Password);
          else
          {
            i++;
	    if (i<argc)
              strcpy((argv[i]), Password);
          }
          break;
        case 'a':
          if ((argv[i]+2) != 0)
            strcpy((argv[i]+2), Application);
          else
          {
            i++;
	    if (i<argc)
              strcpy((argv[i]), Application);
          }
          break;
        case 'd':
	  switch (*(argv[i]+2))
	  {
	    case 'n':
              if (*(argv[i]+3) != '-')
  	        disp_attrname = TRUE;
	      else
  	        disp_attrname = FALSE;
	      break;
	    case 't':
              if (*(argv[i]+3) != '-')
	        disp_attrtype = TRUE;
	      else
	        disp_attrtype = FALSE;
	      break;
	    case 'r':
              if (*(argv[i]+3) != '-')
	        disp_recnum = TRUE;
	      else
	        disp_recnum = FALSE;
	      break;
	    case 'd':
              if (*(argv[i]+3) != '-')
	        disp_descr = TRUE;
	      else
	        disp_descr = FALSE;
	      break;
	    case 'l':
	      if (*(argv[i]+3) != 0)
	        sscanf((argv[i]+3), "%d", &disp_textl);
	      else
	      {
	        i++;
                if (i<argc)
	          sscanf((argv[i]), "%d", &disp_textl);
	      }
	      break;
	    case 'm':
	      if (*(argv[i]+3) != 0)
	        sscanf((argv[i]+3), "%d", &disp_mode);
	      else
	      {
	        i++;
	        if (i<argc)
	          sscanf((argv[i]), "%d", &disp_mode);
	      }
	      break;
	    default:
	      printf(wbHdr);
	      printf(napoveda);
	      return -1;
	  }
          break;
        default:
          printf(wbHdr);
	  printf(napoveda);
	  return -1;
      }
    }
    else 
    {
      printf(wbHdr);
      printf(napoveda);
      return -1;
    }
  }

  //kontrola nastaveni parametru
  if (ServerName[0]==0) 
  { 
    printf("Nenasel se ServerName\n");
    return -1; //bez jmena serveru nepracuju
  }
  if (LoginName[0]==0) 
  { 
    if (verbose)
      printf("Nenasel se LoginName, pouziji Anonymous\n");
  }
  if (Password[0]==0) 
  { 
    if (verbose)
      printf("Nenasel se Password, pouziji prazdne heslo\n");
  }
  if (Application[0]==0) 
  { 
    printf("Nenasel se Application\n");
    return -1; //bez jmena aplikace nepracuju
  }

  if (verbose)
  {
    //vypis nastavenych parametru
    printf(wbHdr);
    printf("\nPracuji s temito parametry :\n\n");
    printf("Cesta k ini souboru : %s \n", inicesta);
    printf("ServerName          : %s \n", ServerName);
    printf("LoginName           : %s \n", LoginName);
    printf("Password            : %s \n", Password);
    printf("Application         : %s \n", Application);
    printf("\n");
  }
  cdp_init(cdp);
  if (link_kernel(ServerName, 0)!=KSE_OK)
  { printf("Nezdarilo se pripojeni k serveru\n");
    return -1;
  }
  if (verbose)
    printf("link_kernel OK\n");
  int res=interf_init(cdp, PT_REMOTE);
  if (res)
  {
   printf("interf_init error %d.\n", res);
   return -1;
  }
  if (verbose)
    printf("interf_init OK\n");
  connected=TRUE;  ttablenum tabnum;  trecnum cnt1, cnt2;
  if (cd_Login(cdp, LoginName, Password)) 
    write_error_info("Login");
  else 
    if (cd_Set_application(cdp, Application)) 
      write_error_info("Set_application");
    else 
    {
      int r1,r2;
    	cd_Connection_speed_test(cdp, &r1, &r2);
	    printf ("\nConnection speed: %i, %i \n", r1, r2);
      while (Do_SQL());
    };
  cd_interf_close(cdp);
  connected=FALSE;
  core_release();
  if (verbose)
    printf(storedOK);
}

CFNC BOOL WINAPI SendToWeb(char *label,char *text_to_send) { return FALSE; }
CFNC BOOL WINAPI SetUserError(char *errmsg) { }
CFNC BOOL WINAPI SetSTWError(char *errmsg) { return FALSE; }
CFNC BOOL WINAPI GetValue(char *varname,sig16 index,char *value) { return FALSE; }
CFNC sig16 WINAPI GetValueCount(char *varname) { return 0; }
CFNC sig16 WINAPI GetVarCount() { return 0; }
CFNC BOOL WINAPI GetVar(sig16 pos,char *varname) { return FALSE; }
CFNC BOOL WINAPI GetVarValue(sig16 pos,char *varvalue) { return FALSE; }
