#
#  winbase client makefile
#

# paths setup
#############

CLI_DIR=.
SRV_DIR=../srv
ED_DIR=../../wbed
COMM_DIR=../comm


# specific
# ########

obj_dir  = $(CLI_DIR)/objs.linux
inc_dirs = -I$(COMM_DIR) -I$(SRV_DIR) -I$(ED_DIR)
defines  = -DUNIX -DDBG -DNWCL
commflg  = -funsigned-char -W -pthread -D_THREAD_SAFE

comp_opt_fast = -c $(defines) $(inc_dirs) $(commflg) -O0 -o$@ -ggdb
comp_dbg_fast = -D_DEBUB -DDBG
compiler      = gcc
compiler_cmd  = $(compiler) $(comp_opt_fast) $(comp_dbg_fast) 

linker = gcc
startup =
libs = -lwb602 -lm -lpthread

program = wbcl

objlst  = $(obj_dir)/wbcl.o 

BASHDR = $(CLI_DIR)/defs.h $(COMM_DIR)/winrepl.h $(CLI_DIR)/cint.h \
        $(CLI_DIR)/comp.h
EDHDR = $(ED_DIR)/edtypes.h $(ED_DIR)/ed.h $(ED_DIR)/edrsa.h 

all : $(obj_dir)/$(program)

$(obj_dir)/$(program) : $(objlst)
	$(linker) $(startup) $(objlst) $(libs) -o$(obj_dir)/$(program)
	chmod 777 $(obj_dir)/$(program)

$(obj_dir)/wbcl.o : $(CLI_DIR)/wbcl.cpp $(BASHDR) 
	$(compiler_cmd) $(CLI_DIR)/wbcl.cpp

