// wbdefs.h - spolecne defnice pro server i klienta

#ifdef _MSC_VER
#pragma warning( disable : 4200 4201 4237 4245 4514 4244 4127 4100 4310 4305 4306 4018)
#pragma warning( 3 : 4121 4505)
#endif

/****************************************************************************/
/* general.h - zakladni spolecne definice pro praci s WinBase602            */
/* (C) Janus Drozd, 1992, 93, 94                                            */
/****************************************************************************/

#ifndef GENERAL_DEF
#define GENERAL_DEF

#ifdef WINS
#ifndef __WIN32__
#define __WIN32__
#endif
#endif
#ifdef __WIN32__
#ifndef WINS
#define WINS
#endif
#endif

#ifdef WINS

#define DllImport __declspec(dllimport)
#define DllExport __declspec(dllexport)
#define oexport
#if defined(KERN)
#define DllKernel __declspec(dllexport)
#else
#define DllKernel __declspec(dllimport)
#endif
#if defined(PREZ)
#define DllPrezen __declspec(dllexport)
#else
#define DllPrezen __declspec(dllimport)
#endif
#ifdef VIEW
#define DllViewed __declspec(dllexport)
#else
#define DllViewed __declspec(dllimport)
#endif
#ifdef INST
#define DllInstserv __declspec(dllexport)
#else
#define DllInstserv __declspec(dllimport)
#endif
#ifdef WBED
#define DllWbed __declspec(dllexport)
#else
#define DllWbed __declspec(dllimport)
#endif

#else // !WINS
#ifdef     NWCL
#define DllImport
#define DllExport
#define DllKernel
#define DllPrezen
#define DllViewed
#define DllWbed
#define oexport
#ifdef UNIX
#define __stdcall
#endif
#define ODBCDRV

#else  /* !WINS && !NWCL */

#define DllImport
#define DllExport
#define DllKernel
#define DllPrezen
#define DllViewed
#define DllInstserv
#define DllWbed
#ifdef UNIX
#define oexport
#define __stdcall
#else
#define oexport   _export
#endif

#endif // !NWCL
#endif // !WINS

////////////////////////////////////////////////////////////////
#include "general.h"

#endif   /* neni definovano GENERAL_DEF */

// Doplnky ke general.h:
/*************** Atributy systemovych tabulek TABTAB A OBJTAB ***************/
#define SYSTAB_PRIVILS_ATR 2
#define TAB_DRIGHT_ATR     8   /* data rights */
#define TAB_BASBL_ATR      9   /* basblock number */

/******************************* Kategorie: *********************************/
#define OLD_CATEG_CONNECTION 28
#define OLD_CATEG_RELATION   29

#define XCATEG_SERVER			0x31
#define XCATEG_UNCONN			0x32
#define XCATEG_CATEG			0x33
#define XCATEG_SYSTEM			0x34

/******************** zde konci uzivatelske kernel.h ************************/
#define CD_DIALOG_HELP  255   /* universal in dialogs */

#ifdef __BORLANDC__
#define __try        try
#define _tell        tell
#define _diskfree_t  diskfree_t
#define _find_t      find_t
#endif
#ifdef __WATCOMC__
#define _tell        tell
#endif

#ifdef __WIN32__
#undef  FreeProcInstance
#define FreeProcInstance(x)
#endif

#if !defined(__WIN32__)
#define GlobalPtrHandle(lp) ((HGLOBAL)LOWORD(GlobalHandle(SELECTOROF(lp))))
#else
#define GlobalPtrHandle(lp) ((HGLOBAL)GlobalHandle(lp))
#endif

#define OUT_OF_CURSOR  3   /* interni pouziti (returned only by Recstate) */

#define LINK_MASK     0x7f
#define IS_STARTER    0x40
typedef uns32 timestamp;

#define NOT_LINKED ((uns16)-2)
#define NW_OBJ_LEN     48

extern byte tNONEREAL[8];
#define NULLREAL (*(double*)tNONEREAL)
extern char NULLSTRING[1];
#define MONEY_SIZE  6

#define IS_NULLMONEY(m) (((m)->money_hi4==NONEINTEGER) && !(m)->money_lo2)

struct  cd_t;
typedef cd_t * cdp_t;
struct  run_state;
struct t_express;

#define CATEG2SYSTAB(cat) (ttablenum)(((cat) & CATEG_MASK)==CATEG_TABLE ?\
  TAB_TABLENUM :\
  (cat)==CATEG_USER || (cat)==CATEG_GROUP ? USER_TABLENUM : OBJ_TABLENUM)

extern "C" {
  DllKernel uns8  WINAPI cUPCASE  (uns8 ch); /* converts CS letters to upper-case */
  DllKernel BOOL  WINAPI UPLETTER(uns8 ch);
  DllKernel BOOL  WINAPI SYMCHAR (uns8 ch); /* is UPLETTER or digit ? */
  DllKernel short WINAPI cmpstr(const char * ss1, const char * ss2, short maxlen, int tp);
  DllKernel BOOL  WINAPI is_string(unsigned tp);
  DllKernel BOOL  WINAPI speciflen(unsigned tp);
  DllKernel void  WINAPI small_string(tptr s, BOOL captfirst);
  DllKernel BOOL  WINAPI specname(const char * p);
  DllKernel void  WINAPI copy_name(char * dest, const char * name);
}
extern uns8 csconv[256];
extern uns8 letters[128];
#define mcUPCASE(c) csconv[c]
#define mUPLETTER(ch) ((ch<128) ? ((ch>='A') && (ch<='Z') || (ch=='_')) : \
                           letters[ch-128])

#include <string.h>

#define MAX_INDEX_PARTS    8
#define MAX_KEY_LEN     1000
#define REC_REMAP_SIZE    70   /* size of recnum remap array */
#define SELFPTR           ((ttablenum)-1)
#define RELOC_MARK      0xdf
#define INDX_MAX          24
#define CURS_USER     0x8000
#define CURS_MASK     0x1fff  /* table number bits in standard cursors */
#define IS_OPEN_CURSOR(curs) (((curs) & 0xc000) == 0x8000)
#define ATTRNAMELEN       31  /* the max. number of characters in an attribute name */
#define UUID_SIZE         12
typedef uns8 WBUUID[UUID_SIZE];

#define SYSTEM_TABLE(tbnum) ((tbnum)<=KEY_TABLENUM && (sig32)(tbnum)>=TAB_TABLENUM)
 /* Must recognize cursor numbers and temporary tables! */

/********************** the attribute types and its codes ********************/
#define ATT_UNTYPED   23
#define ATT_MARKER    24
#define ATT_INDNUM    25
#define ATT_INTERVAL  26
#define ATT_NIL       27  /* any value distinct from other ATTs */
#define ATT_FILE      28
#define ATT_TABLE     29
#define ATT_CURSOR    30
#define ATT_DBREC     31
#define ATT_VARLEN    32
#define ATT_UNUSED    33
#define IS_STRING(tp) ((tp) >= ATT_STRING && (tp) <= ATT_CSISTRING)
#define SPECIFLEN(tp) ((tp) >= ATT_STRING && (tp) <= ATT_BINARY)
#define TYPESIZE(att) ((att->attrtype>=ATT_STRING && att->attrtype<=ATT_BINARY)\
                      ? att->attrspecif : tpsize[att->attrtype])
extern uns8 tpsize[ATT_UNUSED];  /* located in comm0 and dataproc */
#define ATT_ODBC_NUMERIC   40
#define ATT_ODBC_DECIMAL   41
#define ATT_ODBC_TIME      42
#define ATT_ODBC_DATE      43
#define ATT_ODBC_TIMESTAMP 44
#define IS_HEAP_TYPE(tp) ((tp)>=ATT_FIRST_HEAPTYPE && (tp)<=ATT_LAST_HEAPTYPE)
#define IS_ODBC_TYPE(tp) ((tp)>=ATT_ODBC_NUMERIC   && (tp)<=ATT_ODBC_TIMESTAMP)

/* lock numbers */
#define RLOCK    0x80
#define WLOCK    0x40
#define TMPWLOCK 0x20  /* remove this lock at commit time */
#define TMPRLOCK 0x10  /* remove this lock at commit time */
#define ANY_LOCK 0xf0  // removes all types of locks

typedef struct
{ ttablenum tabnum;
  trecnum   recnum;
  tobjnum   usernum;
  uns8      locktype;
} lockinfo;

#define MAX_LOG_EVENTS 20
typedef struct
{ uns16 loc_conn_clients;
  uns16 rem_conn_clients;
  uns16 logg_clients;
  uns16 processed_threads;
  uns16 fixed_pages;
  uns16 sum_fixes;
  uns16 installed_tables;
  uns16 locked_tables;
  uns16 sum_table_locks;
  uns16 temp_tables;
  uns16 open_cursors;
  uns16 page_locks;
  uns32 free_memory;
  uns16 recent_events[MAX_LOG_EVENTS];
} t_monitor;

///////////////////////////////// memory ////////////////////////////////////
HGLOBAL wb_system_alloc(uns32 size, BOOL shared, tptr * ptr);
void    wb_system_free(void * ptr, HGLOBAL handle);
void    wb_system_freeptr(void * ptr);

extern "C" {
  DllKernel void   WINAPI safefree(void * * px);
  DllKernel void * WINAPI corerealloc(void * x, unsigned y);
  DllKernel void   WINAPI memmov(void * destin, const void * source, unsigned size);
  DllKernel uns32  WINAPI free_sum(void);
  DllKernel int    WINAPI used_client_memory(void);
  DllKernel BOOL   WINAPI is_core_management_open(void);
  DllKernel void   WINAPI heap_test(void);
}
#define OW_CINT       1
#define OW_QBE        2
#define OW_COMPIL     3
#define OW_VDEF       4
#define OW_GENINC     5
#define OW_TABDEF     6
#define OW_FSED       7
#define OW_OBJDEF     8
#define OW_PTRS       9
#define OW_PREZ      10
#define OW_CURDEF    11
#define OW_IMPORT    12
#define OW_PGRUN     13
#define OW_WINDOWS   14
#define OW_CUROP     15
#define OW_CODE      16
#define OW_ASC       17
#define OW_PRINT     18
#define OW_CONSTRAIN 19
#define OW_FILESEL   20
#define OW_DIROP     21
#define OW_HELP      22
#define OW_MENU      23
#define OW_NETWORK   24

#define OW_WORM     101
#define OW_FRAMES   102
#define OW_TABLE    103
#define OW_REMAP    104
#define OW_BTREE    105
#define OW_RIGHT    106
#define OW_ANSW     107
#define OW_SEEK     108
#define OW_CURSOR   109
#define OW_MAINT    110
#define OW_MAINTAN  111
#define OW_HIST     112

#include "wbapiex.h"
//////////////////////////// dynar //////////////////////////////////////
class DllKernel t_dynar
{
protected:   
  unsigned elcnt;    /* number of array elements in use */
  unsigned arrsize;  /* number of allocated array elements */
  unsigned elsize;   /* array element size in bytes */
  unsigned step;     /* allocation step (number of new elements) */
  tptr elems;
 public:
  void * acc2(unsigned index);
  inline void * acc(unsigned index)
    { return (index < elcnt) ? elems+(index*elsize) : acc2(index); }
  inline void * acc0(unsigned index) const
    { return elems+(index*elsize); }
  void   minimize(void);
  int    find(void * pattern);
  inline int count(void) const   { return elcnt; }
  inline unsigned el_size(void) const { return elsize; }
  void   init(unsigned c_elsize, unsigned c_arrsize = 0, unsigned c_step = 1);
  inline t_dynar(unsigned c_elsize, unsigned c_arrsize = 0, unsigned c_step = 1)
    { init(c_elsize, c_arrsize, c_step); }
  inline ~t_dynar(void)
    { if (arrsize) { corefree(elems);  elems=NULL;  arrsize=elcnt=0; } }
  BOOL   delet(unsigned index);
  BOOL   ord_delet(unsigned index);
  void * insert(unsigned index);
  inline void * next(void) { return acc(elcnt); }
  void init_elem(void * elptr);
  void drop(void);
  inline void clear(void) { elcnt=0; }
#ifdef SRVR
  void mark_core(void);
#else
  void mark_core(void) { }
#endif
/* Axioms:
  1. sizeof(*elems) == arrsize*elsize;
  2. arrsize >= elcnt;
  3. elems!=NULL iff arrsize!=0;
  4. < elems[elsize*elcnt] , elems[elsize*arrsize] ) is nulled;
*/
};

#define SPECIF_DYNAR(name,elemtype,step) class name : public t_dynar   \
{public:                                                          \
  inline elemtype * acc(unsigned index)                           \
    { return (elemtype *)t_dynar::acc(index); }                   \
  inline elemtype * acc0(unsigned index) const                    \
    { return (elemtype *)t_dynar::acc0(index); }                  \
  inline elemtype * acc2(unsigned index)                          \
    { return (elemtype *)t_dynar::acc2(index); }                  \
  inline elemtype * next(void)                                    \
    { return (elemtype *)t_dynar::next(); }                       \
  inline void init(unsigned c_arrsize = 0, unsigned c_step = step)\
    { t_dynar::init(sizeof(elemtype),c_arrsize,c_step); }         \
  inline name(unsigned c_arrsize = 0, unsigned c_step = step) :   \
    t_dynar(sizeof(elemtype),c_arrsize,c_step) {}                 \
}

/**************************** table definition in table_all *****************************/
// flags stored in tabdef_flags (common for table_all and table_descr):
#define TFL_NO_JOUR      0x0001
#define TFL_UNIKEY       0x0002
#define TFL_ZCR          0x0004
#define TFL_TOKEN        0x0008
#define TFL_DETECT       0x0010
#define TFL_VARIANT      0x0020
#define TFL_REC_PRIVILS  0x0040
#define TFL_DOCFLOW      0x0080
#define TFL_REPL_DEL     0x0100
#define TFL_LUO          0x0200

// table constrain type (stored in ind_descr.index_type and any_constrain.ccateg):
#define INDEX_PRIMARY    1
#define INDEX_UNIQUE     2
#define INDEX_NONUNIQUE  3
#define CHECK_CONSTR    10
#define REFER_CONSTR    20
#define DISTINCT(ind) ((ind)->ccateg <= INDEX_UNIQUE)
#define CONSTR_IS_INDEX(cc) ((cc)->any.ccateg<CHECK_CONSTR)

// values of update_rule and delete_rule in forkey_constr:
#define REFRULE_NO_ACTION   1
#define REFRULE_SET_NULL    2
#define REFRULE_SET_DEFAULT 3
#define REFRULE_CASCADE     4

typedef enum { ATR_NEW=0, ATR_OLD, ATR_DEL, ATR_MODIF } tag_atr_state;

struct double_name // object name possibly prefixed by a schema name
{ tobjname objname;
  tobjname schemaname; // "" iff schema not specified
};

SPECIF_DYNAR(name_dynar, double_name, 3);

typedef struct
{ uns8 attrnum;   /* used only if no expression provided */
  uns8 type;
  uns8 size;
  wbbool desc;
  t_express * expr;
} part_desc;

struct ind_descr
{ tobjname constr_name;
  uns32 atrmap[256/32];
  uns8  index_type;
  uns8  partnum;
  uns16 keysize;
  part_desc part[MAX_INDEX_PARTS];
  tptr text;               /* expression text */
  name_dynar reftables;    /* names of referencig tables */
  uns8  state;             // altering state, type tag_atr_state
  ind_descr(void);
  ~ind_descr(void);        /* destructor for reftables called automatically */
  void mark_core(void);
};

struct check_constr
{ tobjname constr_name;
  uns32 atrmap[8];
  tptr text;             /* expression text */
  t_express * expr;      // compiled check expression
  uns8  state;           // altering state, type tag_atr_state
  ~check_constr(void);
};

class index_dynar : public t_dynar
{
 public:
  inline ind_descr * acc(unsigned index)
    { return (ind_descr*)t_dynar::acc(index); }
  inline ind_descr * acc0(unsigned index)
    { return (ind_descr*)t_dynar::acc0(index); }
  BOOL delet(unsigned index);
  inline ind_descr * next(void)
    { return (ind_descr*)t_dynar::next(); }
  inline void init(unsigned c_arrsize = 0, unsigned c_step = 1)
    { t_dynar::init(sizeof(ind_descr),c_arrsize,c_step); }
  inline index_dynar(unsigned c_arrsize = 0, unsigned c_step = 1) :
    t_dynar(sizeof(ind_descr),c_arrsize,c_step) {}
  ~index_dynar(void);
};

struct forkey_constr
{ tobjname constr_name;
  tobjname desttab_name;
  tobjname desttab_schema;
  ttablenum desttabnum;
  tptr  text;            /* expression text */
  uns16 loc_index_num;
  uns16 par_index_num;
  tptr  par_text;        /* expression text or NULL iff using the primary key of the parent */
  uns8  update_rule, delete_rule;
  uns8  state;           // altering state, type tag_atr_state
  ~forkey_constr(void)
    { delete text;  delete par_text;  text=par_text=NULL; }
};

class check_dynar : public t_dynar
{
 public:
  inline check_constr * acc(unsigned index)
    { return (check_constr*)t_dynar::acc(index); }
  inline check_constr * acc0(unsigned index)
    { return (check_constr*)t_dynar::acc0(index); }
  BOOL delet(unsigned index);
  inline check_constr * next(void)
    { return (check_constr*)t_dynar::next(); }
  inline void init(unsigned c_arrsize = 0, unsigned c_step = 1)
    { t_dynar::init(sizeof(check_constr),c_arrsize,c_step); }
  inline check_dynar(unsigned c_arrsize = 0, unsigned c_step = 1) :
    t_dynar(sizeof(check_constr),c_arrsize,c_step) {}
  ~check_dynar(void);
};

class refer_dynar : public t_dynar
{
 public:
  inline forkey_constr * acc(unsigned index)
    { return (forkey_constr*)t_dynar::acc(index); }
  inline forkey_constr * acc0(unsigned index)
    { return (forkey_constr*)t_dynar::acc0(index); }
  BOOL delet(unsigned index);
  inline forkey_constr * next(void)
    { return (forkey_constr*)t_dynar::next(); }
  inline void init(unsigned c_arrsize = 0, unsigned c_step = 1)
    { t_dynar::init(sizeof(forkey_constr),c_arrsize,c_step); }
  inline refer_dynar(unsigned c_arrsize = 0, unsigned c_step = 1) :
    t_dynar(sizeof(forkey_constr),c_arrsize,c_step) {}
  ~refer_dynar(void);
};

#define COMMON_ATTR (ATTRNAMELEN+1+2*sizeof(uns8)+sizeof(wbbool)+sizeof(uns16))

typedef struct atr_all
{ char  name[ATTRNAMELEN+1];
  uns8  type;
  uns8  multi;
  wbbool  nullable;
  uns16 specif;           /* string size or destination table number */
  uns8  state;            /* altering state */
  uns8  orig_type;        /* original type */
  uns8  own_check;        /* number of the own check rule */
  tptr  defval;           /* pointer to default value text iff not NULL */
  tptr  alt_value;        /* value used when altering the table   */

  atr_all(void)  { alt_value=defval=NULL; }
  ~atr_all(void) { safefree((void**)&alt_value);  safefree((void**)&defval); }
} atr_all;

class attr_dynar: public t_dynar
{public:
  inline atr_all* acc(unsigned index)
    { return (atr_all*)t_dynar::acc(index); }
  inline atr_all* acc0(unsigned index)
    { return (atr_all*)t_dynar::acc0(index); }
  inline atr_all* next(void)
    { return (atr_all*)t_dynar::next(); }
  inline void init(unsigned c_arrsize = 0, unsigned c_step = 4)
    { t_dynar::init(sizeof(atr_all),c_arrsize,c_step); }
  inline attr_dynar(unsigned c_arrsize = 0, unsigned c_step = 4) :
    t_dynar(sizeof(atr_all),c_arrsize,c_step) {}
  BOOL attr_dynar::delet(unsigned index);
  ~attr_dynar(void);
  inline atr_all * insert(unsigned index)
    { return (atr_all*)t_dynar::insert(index); }
};

class table_all // table definition, CREATE TABLE and ALTER TABLE statements are compiled into it
{public:
  unsigned tabdef_flags; // WinBase private flags
  BOOL     attr_changed; // any column changed (defined when compiling ALTER TABLE statement)
  tobjname selfname;     // table name
  tobjname schemaname;   // schema the table belongs to
  tobjname folder_name;  // folder the table is placed in
  attr_dynar  attrs;  // list of columns, starts with the DELETED column
  name_dynar  names;  // list of destination table names for pointer type columns
  index_dynar indxs;  // list of indicies
  check_dynar checks; // list of check constrains
  refer_dynar refers; // list of foreign keys defined in the table
  BOOL     cascade;      // CASCADE flag, used only in ALTER statement
};

/******************************** d_table ***********************************/
/* flags used in aflags in d_table: */
#define ROWID_FLAG       1
#define ROWVER_FLAG      2
#define NOEDIT_FLAG      4
#define RI_SELECT_FLAG   0x10
#define RI_INSERT_FLAG   0x20
#define RI_UPDATE_FLAG   0x40
#define RI_REFERS_FLAG   0x80

struct d_attr
{ char  name[ATTRNAMELEN+1];
  uns8  type;
  uns8  multi;
  wbbool  nullable;
  uns16 specif;           /* string size or destination table number */
  wbbool  needs_prefix;
  uns8  prefnum;          /* prefix number iff needs_prefix       */
  tattrib unused1;     /* mapping cursor attributes to table attributes */
  uns8    unused2;       /* ... for updatable cursors */
  uns8  a_flags;          /* privilege, rowid, dependent flags */
  inline void base_copy(d_attr * source, int num)
  { memcpy(this, source, sizeof(d_attr));
    name[0]=(uns8)num;
  }
  inline void base_copy(atr_all * source, int num)
  { name[0]=(uns8)num;
    type=source->type;  multi=source->multi;  nullable=source->nullable;
    specif=source->specif;
  }
};

typedef struct
{ uns8  attrcnt;   /* number of attributes */
  uns8  tabcnt;    /* number of prefixes and tables (0 for table descriptor) */
  uns16 tabdef_flags;/* flags derived from the table definition */
  uns16 updatable; /* TRUE for ordinary tables, valid for cursors */
  char selfname  [OBJ_NAME_LEN+1];
  char schemaname[OBJ_NAME_LEN+1];
  d_attr attribs[1];
} d_table;

#define FIRST_ATTR(td)      ((td)->attribs)
#define NEXT_ATTR(td,pattr) ((pattr)+1)
#define ATTR_N(td,n)        ((td)->attribs+(n))
#define NAME_PREFIX(td,i)   ((tptr)((td)->attribs+(td)->attrcnt)+2*i*(OBJ_NAME_LEN+1))
#define COUNTER_DEFVAL      0x80000001LU

void client_deliver_messages(cdp_t cdp, BOOL waitcurs);
extern "C" {
DllKernel void oexport set_table_def_invalid(ttablenum tabnum);         /* to messages */
DllKernel void  WINAPI xgettime(uns8 * ti_sec, uns8 * ti_min, uns8 * ti_hour);
DllKernel void  WINAPI xgetdate(uns8 * da_day, uns8 * da_mon, int  * da_year);
DllKernel void     WINAPI strmaxcpy(char * destin, const char * source, unsigned maxsize);
DllKernel unsigned WINAPI strmaxlen(const char * str, unsigned maxsize);
DllKernel int      WINAPI my_stricmp(const char * str1, const char * str2);
DllKernel void WINAPI deliver_messages(cdp_t cdp, BOOL waitcurs);
DllKernel cdp_t WINAPI GetCurrTaskPtr(void);
DllKernel int   WINAPI compile_table_to_all(cdp_t cdp, const char * defin, table_all * pta);
DllKernel uns8  WINAPI small_char(unsigned char c);
}
DllKernel uns8 WINAPI typesize(d_attr * pdatr);

///////////////////////// users & crypt //////////////////
#include "wbed.h"

#define DB_ADMIN_GROUP   0
#define ANONYMOUS_USER   1
#define EVERYBODY_GROUP  2

#define PUK_NAME1  16
#define PUK_NAME2   2
#define PUK_NAME3  20
#define PUK_IDENT  80

typedef struct
{ char name1[PUK_NAME1+1];
  char name2[PUK_NAME2+1];
  char name3[PUK_NAME3+1];
  char identif[PUK_IDENT+1];
} t_user_ident;

#define RSA_KEY_SIZE  (256+8)  /* maximum */
#define DES_KEY_SIZE  512

#define MD5_SIZE        16
typedef uns8 t_hash[MD5_SIZE];
#define ENC_HASH_SIZE   (256+8)  // MAX_BYTE_PRECISION
typedef uns8 t_enc_hash[ENC_HASH_SIZE];

typedef enum { sigstate_notsigned, sigstate_invalid,  sigstate_changed,
  sigstate_unknown, sigstate_uncertif, sigstate_time, sigstate_notca,
  sigstate_valid, sigstate_error, sigstate_validchng } t_sigstate;

typedef struct
{ uns8         state;       // no reason to sigh this
  WBUUID       key_uuid;    // not signed, used when verifying
  t_user_ident user_ident;  // signed, kvuli zobrazovani
  uns32        dtm;         // date of signing, signed, very important
  t_enc_hash   enc_hash;
} t_signature;

typedef struct
{ uns32    version_id;
  uns8     key_uuid[UUID_SIZE];
  CKeyPair KeyPair;
  uns8     pass_xor;
} t_priv_key_file;

CFNC DllKernel void WINAPI md5_digest(uns8 * input, unsigned len, uns8 * digest);

typedef enum { PKTTP_REPL_DATA=1, PKTTP_REPL_REQ,
               PKTTP_REPL_ACK,    PKTTP_REPL_NOACK,
               PKTTP_STATE_REQ,   PKTTP_STATE_INFO,
               PKTTP_SERVER_INFO, PKTTP_SERVER_REQ,
               PKTTP_REL_REQ,     PKTTP_REL_ACK,
               PKTTP_REL_NOACK,   PKTTP_REPL_UNBLOCK,
               PKTTP_REPL_STOP,
               OPER_RESET_COMM=100, OPER_SKIP_REPL=101
             } t_packet_type;

typedef struct
{ WBUUID srv_uuid;
  WBUUID apl_uuid;
  char   relname[OBJ_NAME_LEN+1];
  uns32  get_def;
  WBUUID dp_uuid, os_uuid, vs_uuid;
} t_relreq_pars;

typedef enum { REPLAPL_NOTHING=0, REPLAPL_REQPOSTED,
               REPLAPL_REQRECV, REPLAPL_IS, REPLAPL_REQREJ, REPLAPL_BLOCKED,
               REPLAPL_INTERR, REPLAPL_DELETED, REPLAPL_CONFLICT }
             t_replapl_states;
typedef struct t_replapl
{ t_replapl_states state;
  char relname[OBJ_NAME_LEN+1];
  uns32 want_def;
  t_replapl(t_replapl_states i_state, char * i_relname, BOOL i_want_def)
    { state=i_state;  strcpy(relname, i_relname);  want_def=i_want_def; }
  t_replapl(void) {}
} t_replapl;

#define USER_ATR_LOGNAME 3
#define USER_ATR_CATEG   4
#define USER_ATR_UUID    5
#define USER_ATR_UPS     6
#define USER_ATR_INFO         7 // readable names, indentification, t_user_ident
#define USER_ATR_SERVER  8
#define USER_ATR_PASSWD       9 // last password + counter
#define USER_ATR_PASSCREDATE 10 // password creation date
#define USER_ATR_STOPPED     11
#define USER_ATR_CERTIF  12

typedef enum { SRV_ATR_NAME=1, SRV_ATR_UUID, SRV_ATR_PUBKEY,
 SRV_ATR_ADDR1, SRV_ATR_ADDR2, SRV_ATR_APPLS, SRV_ATR_RECVNUM, SRV_ATR_FOFFSET,
 SRV_ATR_RECVFNAME, SRV_ATR_SENDNUM, SRV_ATR_ACKN,
 SRV_ATR_SENDFNAME, SRV_ATR_REPLGCR, SRV_ATR_USRGCR, SRV_ATR_USEALT
 } srvtab_attrs;
typedef enum { REPL_ATR_SOURCE=2, REPL_ATR_DEST, REPL_ATR_APPL, REPL_ATR_TAB,
 REPL_ATR_ATTRMAP, REPL_ATR_REPLCOND, REPL_ATR_NEXTTIME, REPL_ATR_GCRLIMIT
 } repltab_attrs;
typedef enum { KEY_ATR_UUID=2, KEY_ATR_USER, KEY_ATR_PUBKEYVAL,
 KEY_ATR_CREDATE, KEY_ATR_EXPIRES, KEY_ATR_IDENTIF, KEY_ATR_CERTIF,
 KEY_ATR_CERTIFS
 } keytab_attrs;

#define ZCR_SIZE 6
typedef uns8 t_zcr[ZCR_SIZE];

extern "C" {
DllKernel void WINAPI create_uuid(WBUUID appl_id);
DllKernel timestamp WINAPI stamp_now(void);
DllKernel void WINAPI bin2hex(char * dest, const uns8 * data, unsigned len);
DllKernel int  WINAPI get_devel_lic(int * licnum);
DllKernel int  WINAPI get_expir_state(void);
}
uns32 clock_now(void);

/* security */
#define MAX_LOGIN_SERVER  79
#define MAX_FIL_PASSWORD  31
#define MAX_SA_PASSWORD  100
typedef enum
{ fil_crypt_no=0, fil_crypt_simple, fil_crypt_fast, fil_crypt_slow
} t_fil_crypt;
typedef  struct
{ uns32  passminlen;
  uns32  passexpires;
  uns32  anonymous_ri;
  char   login_server[MAX_LOGIN_SERVER+1];
  WBUUID top_CA;
  uns32  fil_crypt;
  char   fil_password[MAX_FIL_PASSWORD+1];
  uns8   old_sa_pass[MD5_SIZE];
  uns8   new_sa_pass[MD5_SIZE];
} t_security;

/////////////////////////////// links ////////////////////////////////////
#define LINKTYPE_WB   1
#define LINKTYPE_ODBC 2

typedef struct
{ uns8 link_type; // ==LINKTYPE_WB
  tobjname destobjname;
  uns8 dest_uuid[UUID_SIZE];
} t_wb_link;

extern const char * db_errors[];
extern const char * compil_errors[];
extern const char * kse_errors[];
#ifndef SRVR
extern const char * client_errors[];
extern const char * ipjrt_errors[];
#endif
extern const char * mail_errors[];

#define PRE_KONTEXT  60
#define POST_KONTEXT 40

#define TEMP_TABLE_MARK 4

inline DWORD GetTickDifference (DWORD dwTick, DWORD dwTickRef)
/************************************************************/
{ return dwTick >= dwTickRef ?
         dwTick - dwTickRef :
	 0xffffffffL - dwTickRef + dwTick;
}

typedef unsigned (WINAPI *BEGINTHREAD_START_ROUTINE)(LPVOID lpThreadParameter);
#define LPTHREAD_START_ROUTINE BEGINTHREAD_START_ROUTINE  // overriding std. typedef, CreateThread replaced by _beginthreadex

enum t_cdp_type   { PT_EMPTY=0x00, PT_DIRECT=0x80, PT_REMOTE=0x40, PT_SLAVE=0x20, PT_SERVER=0x10,
                    PT_MAPSLAVE=0x21, PT_WORKER=0x22, PT_KERDIR=PT_MAPSLAVE };

#define LONGJMPBUF CATCHBUF
#define PACKET_PREFIX_SIZE     (sizeof(comm_num_t)+sizeof(uns16))
#define DEFAULT_RQ_FRAME_SIZE  27

void * glob_alloc(uns32 size);
void glob_free(void * ptr);
void * glob_realloc(void * ptr0, uns32 newsize);

typedef struct
{ FARPROC procadr;
  uns16   parsize;
  uns8    fnctype;
  char    dllname[8+1+3+1];
  char    procname[EMPTY_ARRAY_INDEX];
} dllprocdef;

typedef struct libinfo
{ HINSTANCE hLibInst;
  char    libname[8+1+3+1];
  struct libinfo * next_lib;
} libinfo;

typedef uns16 comm_num_t;

#define MIN_ANS_SIZE   24
typedef struct {     /* the beginning of a typical answer */
  uns16 access_key;
  uns16 return_code;
  uns8  dyn_alloc;
  char  return_data[MIN_ANS_SIZE];
               } answer_cb;

typedef struct MsgInfo
{ BYTE *set;    /* start of the full message buffer */
  UINT offset;  /* offset of the next message part  */
  UINT total;   /* total size of the received parts */
} MsgInfo;

typedef struct request_frame {   /* request_frame */
  comm_num_t comm_number;
  uns16 access_key;
  char  areq[1];
               } request_frame;

#ifdef WINS
typedef DWORD     t_thread;   /* WINS */
#else
#ifdef UNIX
typedef pthread_t t_thread;   /* UNIX */
#else
typedef int       t_thread;   /* for NLM */
#endif
#endif

typedef uns16 tmultsize;
typedef uns32 theapsize;
#define CNTRSZ   sizeof(tmultsize) /* size of the multiatribute counter */
#define HPCNTRSZ sizeof(theapsize) /* size of the heap object byte counter */

#define REPLAY_NO_JOURNAL          1    // used by ADMIN.CPP
#define REPLAY_NO_MEMORY           2
#define REPLAY_NO_VALID_RECORD     3
#define REPLAY_BAD_JOURNAL         4
#define REPLAY_LIMIT_REACHED       5

#define RTP_RDONLY     8                // used by ADMIN.CPP
#define RTP_JOUR      16
#define RTP_TRAN      32
#define RTP_SMRT      64
#define RTP_FLUSH    128

enum t_parmode { MODE_IN=1, MODE_OUT=2, MODE_INOUT=3 }; // mode of DPs & embedded vars

struct MARKER  // info about a DP marker in SQL statement, created during compilation
{ int       type;          // 0 if not known
  int       specif;        // type-specific info
  t_parmode input_output;  // bit 1 for INPUT use, bit 2 for OUTPUT use
  int       position;      // offset in the statement, used by server only
};

//////////////////////////// compiler interface ////////////////////////////////
#define FIRST_CLIENT_ERROR       5000
// compiler error numbers
#define COMPILED_OK              0   /* values returned by "compile" */
#define FIRST_COMP_ERROR         1000
#define EOF_IN_COMMENT           1003
#define STRING_EXCEEDS_LINE      1004
#define STRING_TOO_LONG          1005
#define TYPE_EXPECTED            1006
#define LEFT_BRACE_EXPECTED      1007
#define RIGHT_BRACE_EXPECTED     1008
#define DOUBLE_DOT_EXPECTED      1009
#define INTEGER_EXPECTED         1010
#define OF_EXPECTED              1011
#define ARRAY_BOUNDS             1012
#define ARRAY_BIGGER_64          1013
#define IDENT_EXPECTED           1014
#define EQUAL_EXPECTED           1015
#define BAD_CHAR                 1016
#define COMMA_EXPECTED           1017
#define END_OR_SEMICOLON_EXPECTED 1018
#define SEMICOLON_EXPECTED       1019
#define BEGIN_EXPECTED           1020
#define NESTED_SUBROUTINES       1021
#define LEFT_PARENT_EXPECTED     1022
#define RIGHT_PARENT_EXPECTED    1023
#define COLON_EXPECTED           1024
#define BAD_IDENT_CLASS          1025
#define MUST_BE_BOOL             1026
#define DO_EXPECTED              1027
#define ASSIGN_EXPECTED          1028
#define MUST_BE_NUMERIC          1029
#define MUST_BE_INTEGER          1030
#define BAD_OPERATION            1031
#define INCOMPATIBLE_TYPES       1032
#define MONEY_MULTIPLY           1033
#define NOT_A_REC                1034
#define NOT_A_PTR                1035
#define NOT_AN_ARRAY             1036
#define IDENT_NOT_DEFINED        1037
#define ITEM_IDENT_EXPECTED      1038
#define INDEX_NOT_INT            1039
#define THEN_EXPECTED            1040
#define COMMA_OR_SEMIC_EXPECTED  1041
#define TOO_MANY_PARAMS          1042
#define DOT_EXPECTED             1043
#define NUMBER_TOO_BIG           1044
#define STATEMENT_EXPECTED       1045
#define TOO_MANY_ALLOC           1046
#define TOO_BIG_TO_BE_STAT       1047
#define BAD_TAIL                 1048
#define ID_DECLARED_TWICE        1049
#define BAD_FUNCTION_TYPE        1050
#define CODE_GEN                 1051
#define GARBAGE_AFTER_END        1052
#define NESTED_DB_ACCESS         1053
#define NO_LENGTH                1054
#define INDEX_MISSING            1055
#define NOT_STRUCTURED_TYPE      1056
#define VIEW_DOES_NOT_EXIST      1057
#define DEF_READ_ERROR           1058
#define OUT_OF_MEMORY            1059 
#define TO_OR_DOWNTO_EXPECTED    1060
#define UNDEF_ATTRIBUTE          1061
#define FAKTOR_EXPECTED          1062
#define CURSOR_DOES_NOT_EXIST    1063
#define BAD_AGGREG               1064
#define BAD_TIME                 1065
#define BAD_DATE                 1066
#define BAD_DB_ASSGN             1067
#define NOT_VAR_LEN              1068
#define TABLE_DOES_NOT_EXIST     1069
#define UNDEF_ACTION             1070
#define BACKSLASH_EXPECTED       1071
#define UNTIL_EXPECTED           1072
#define DIFFERENT_PROJECT        1073
#define END_EXPECTED             1074
#define VIEW_COMP                1075   /* copy in messages.c */
#define STRING_EXPECTED          1076
#define NOSPEC_ERROR             1077
#define INT_OUT_OF_BOUND         1078
#define TOO_COMPLEX_VIEW         1079
#define DEF_KEY_EXPECTED         1080
#define BAD_IDENT                1081
#define GROUP_ORDER              1082
#define TOO_MANY_ITEMS           1083
#define ITEM_EXPECTED            1084
#define BAD_CURSOR_DEF           1085
#define TOO_MANY_MENU_ITEMS      1086
#define INCLUDE_NOT_FOUND        1087

#define ID_DUPLICITY             1089
#define SEMICOLON_ELSE           1090
#define TOO_MANY_TABLE_ATTRS     1091
#define TOO_MANY_INDXS           1092
#define NO_ATTRS_DEFINED         1093
#define BRACE_NOT_ALLOWED        1094
#define DUPLICATE_NAME           1095    // constrain name duplicity
#define TOO_MANY_INDEX_PARTS     1096
#define BAD_TYPE_IN_INDEX        1097
#define INDEX_KEY_TOO_LONG       1098
#define BAD_TABLE_SYNTAX         1099
#define INDEX_TOO_COMPLEX       1100
#define TOO_MANY_CURS_TABLES    1101
#define FROM_OMITTED            1102
#define TABLE_NAME_EXPECTED     1103
#define SQL_SYNTAX              1104
#define BAD_SQL_PREDICATE       1105
#define SELECT_EXPECTED         1106
#define FROM_EXPECTED           1107
#define AGGR_IN_WHERE           1108
#define AGGR_NESTED             1109
#define ONLY_FOR_COUNT          1110     /* SUM(*) */
#define GENERAL_SQL_SYNTAX      1111
#define AND_EXPECTED            1112     /* Y BETWEEN X ... */
#define OUTER_EXPECTED          1113
#define JOIN_EXPECTED           1114
#define ERROR_IN_FROM           1115     /* bad object in FROM clause */
#define BY_EXPECTED             1116     /* ORDER ..., GROUP ... */
#define UNKNOWN_TYPE_NAME       1117     /* may be misformed, e.g. LONG CHAR */
#define GENERAL_TABDEF_ERROR    1118     /* altering bad table */
#define KEY_EXPECTED            1119     /* FOREING ..., PRIMARY ... */
#define CURSOR_STRUCTURE_UNKNOWN 1120
#define REFERENCES_EXPECTED     1121     /* tabdef */
#define ATTRIBUTE_NOT_FOUND     1122     /* dropping or altering attr. in tabdef */
#define PRECISION_EXPECTED      1123     /* DOUBLE ... */
#define NULL_EXPECTED           1124     /* NOT ... constrain in tabdef, IS NULL */
#define NOT_AN_SQL_STATEMENT    1125
#define TO_EXPECTED             1126
#define ON_EXPECTED             1127
#define INTO_EXPECTED           1128
#define VALUES_EXPECTED         1129
#define BAD_AGGR_FNC_ARG_TYPE   1130
#define SET_EXPECTED            1131     /* UPDATE sql statement */
#define CANNOT_DELETE_IN_THIS_VIEW 1132
#define CANNOT_UPDATE_IN_THIS_VIEW 1133
#define TOO_MANY_INSERT_VALUES  1134
#define SELECT_LISTS_NOT_COMPATIBLE 1135
#define SELECT_LISTS_TOO_MUCH_DIFFERENT 1136
#define BAD_NUMBER_IN_ORDER_BY  1137
#define AGGR_IN_ORDER           1138
#define UPDATE_EXPECTED         1139
#define CURSOR_NOT_UPDATABLE    1140
#define NO_PARENT_INDEX         1141
#define NAME_DUPLICITY          1142     // column name duplicity
#define TWO_PRIMARY_KEYS        1143
#define INDEX_EXPECTED          1144
#define AS_EXPECTED             1145
#define NO_READ_RIGHT           1146
#define NO_LOCAL_INDEX          1147
#define COMBO_SELECT            1148
#define SUBROUTINE_TOO_BIG      1149
#define CANNOT_INSERT_INTO_THIS_VIEW 1150
#define ERROR_IN_DEFAULT_VALUE  1151
#define NO_WRITE_RIGHT          1152
#define CURSOR_RECURSION        1153
#define BAD_CHAR_IN_HEX_LITERAL 1154
#define FORWARD_OPEN            1155
#define PTR_OPEN                1156
#define NO_COMMON_COLUMN_NAME   1157  // WB 5.1 errors
#define NO_REFERENCE_PRIVILEDGE 1158
#define SUBQUERY_IN_AGGR        1159
#define IN_EXPECTED             1160
#define DATETIME_FIELD_EXPECTED 1161
#define BOOLEAN_CONSTANT_EXPECTED 1162
#define NOT_NOT_ALLOWED         1163
#define NOT_SCALAR_SUBQ         1164
#define INVALID_IN_ATOMIC_BLOCK 1165
#define IF_EXPECTED             1166
#define LOOP_EXPECTED           1167
#define RETURNS_EXPECTED        1168
#define PROCEDURE_EXPECTED      1169
#define KEYWORD_PARAM_EXPECTED  1170
#define DUPLICATE_ACTUAL_PARAM  1171
#define BAD_PARAMETER_MODE      1172
#define RETURN_OUTSIDE_FUNCTION 1173
#define CANNOT_CHANGE_CONSTANT  1174
#define CONSTANT_MUST_HAVE_VAL  1175
#define SQLSTATE_EXPECTED       1176
#define FOR_EXPECTED            1177
#define SQLSTATE_FORMAT         1178
#define FOUND_EXPECTED          1179
#define INTERNAL_COMP_ERROR     1180
#define BAD_INTO_OBJECT         1181
#define HANDLER_EXPECTED        1182
#define REDO_UNDO_ATOMIC        1183
#define REPEAT_EXPECTED         1184
#define WHILE_EXPECTED          1185
#define CURSOR_EXPECTED         1186
#define SAVEPOINT_EXPECTED      1187
#define CHAIN_EXPECTED          1188
#define TRANSACTION_EXPECTED    1189
#define DUPLICATE_SPECIFICATION 1190
#define SPECIF_CONFLICT         1191
#define CASE_EXPECTED           1192
#define FOR_CURSOR_INVALID      1193
#define CURSOR_IS_INSENSITIVE   1194
#define AGGR_NO_KONTEXT         1195
#define NAME_EXPECTED           1196  // keyword NAME meant
#define THIS_TYPE_NOT_ENABLED   1197
#define OBJECT_EXPECTED         1198
#define BEFORE_OR_AFTER_EXPECTED 1199
#define TRIGGER_EVENT_EXPECTED  1200
#define OLD_OR_NEW_EXPECTED     1201
#define TRANSIENT_TABLES_NOT_SUPP 1202
#define EACH_EXPECTED           1203
#define ROW_OR_STAT_EXPECTED    1204
#define TRIGGER_EXPECTED        1205
#define BAD_TARGET              1206
#define FEATURE_NOT_SUPPORTED   1207
#define OTHER_COLS_NOT_ALLOWED  1208
#define ABSTRACT_CLASS_INSTANCE 1209
#define CANNOT_SET_PROJECT      1210
#define BAD_METHOD_OR_PROPERTY  1211
#define CONTROLS_NOT_KNOWN      1212
#define THISFORM_UNDEFINED      1213
#define UNDEFINED_DIRECTIVE     1214
#define EOF_IN_MACRO_EXPANSION  1215
#define UNEXPECTED_DIRECTIVE    1216
#define EOF_IN_CONDITIONAL      1217
#define APPL_IS_LOCKED          1218
#define TYPELIB_ERROR           1219
#define WITH_EXPECTED           1220
#define BAD_SEQUENCE_PARAMS     1221

#define LAST_COMP_ERROR         1299

#define ERR_WITH_MSG(err)        ((err)==BAD_IDENT_CLASS      ||\
  (err)==ATTRIBUTE_NOT_FOUND   || (err)==TABLE_DOES_NOT_EXIST ||\
  (err)==ID_DECLARED_TWICE     || (err)==IDENT_NOT_DEFINED    ||\
  (err)==CURSOR_DOES_NOT_EXIST || (err)==UNDEF_ATTRIBUTE      ||\
  (err)==REFERENTIAL_CONSTRAIN || (err)==CHECK_CONSTRAIN      ||\
  (err)==CANNOT_SET_PROJECT    || (err)==BAD_METHOD_OR_PROPERTY ||\
  (err)==MUST_NOT_BE_NULL      || (err)==KEY_DUPLICITY        ||\
  (err)==OBJECT_NOT_FOUND      || (err)==TABLE_DAMAGED        ||\
  (err)==CONTROLS_NOT_KNOWN    || (err)==IE_DOUBLE_PAGE       ||\
  (err)==SEQUENCE_EXHAUSTED    || (err)==NO_CURRENT_VAL       ||\
  (err)==EOF_IN_MACRO_EXPANSION|| (err)==EOF_IN_CONDITIONAL  )
#define SET_ERR_MSG(cdp, msg) strmaxcpy((cdp)->errmsg, msg, sizeof(tobjname))

struct objtable;
union  typedescr;
struct typeobj;
union  object;
struct compil_info;
typedef compil_info * CIp_t;
typedef short symbol;
typedef uns32 code_addr;

union basicval0    /* the basic simple value - 8 bytes */
{ sig32   int32;
  byte    money[6];
  monstr  moneys;
  double  real;
  sig16   int16;
  uns8    int8;
  tptr    ptr;
};

#define PTR_SIZE 4 /* 4 bytes for pointer value */
typedef struct {   /* object definition */
  tname name;          /* object's name */
  union object * descr;      /* pointer to the description of the object */
               } objdef;
typedef struct {
  uns8 typecateg;
  unsigned valsize;
               } anytype;
typedef struct {
  uns8 typecateg;
  unsigned valsize;
  int      lowerbound;
  int      elemcount;
  struct typeobj * elemtype;
               } arraytype;
typedef struct {
  uns8 typecateg;
  unsigned valsize;   /* limited to 0x7ffe */
               } stringtype;
typedef struct {
  uns8 typecateg;
  unsigned valsize;   /* limited to 0xff */
               } binarytype;
typedef struct {
  uns8 typecateg;
  unsigned valsize;
  struct objtable * items;
               } recordtype;
typedef struct {
  uns8 typecateg;
  unsigned valsize;
  struct typeobj * domaintype;
               } ptrtype;
typedef struct {
  uns8 typecateg;
  unsigned valsize;
  struct typeobj * domaintype;
  tobjname domainname;
               } fwdptrtype;
struct viewtype 
{ uns8     typecateg;
  unsigned valsize;
  tobjname viewname;
  tobjnum  objnum; // used by compiler only, not valid at run time
};
#define T_ARRAY  128
#define T_RECORD 129
#define T_PTR    130
#define T_FILE   131
#define T_STR    132
#define T_CSSTR  133
#define T_CSISTR 134
#define T_RECCUR 135
#define T_BINARY 136
#define T_PTRFWD 137
#define T_VIEW   138
typedef union typedescr {
  arraytype  array;
  anytype    anyt;
  recordtype record;
  stringtype string;
  binarytype binary;
  ptrtype    ptr;
  fwdptrtype fwdptr;
  viewtype   view;
              } typedescr;
#define O_CONST   1
#define O_TYPE    2
#define O_PROC    3
#define O_SPROC   4
#define O_FUNCT   5
#define O_VAR     6
#define O_VALPAR  7
#define O_REFPAR  8
#define O_RECELEM 9
#define O_unused  10
#define O_CURSOR  11
#define O_AGGREG  12
#define O_TABLE   13
#define O_METHOD  14
#define O_PROPERTY 15
#define O_INFOVIEW 16  // server only - system information view

typedef struct { /* beginning of the description of any object */
  uns8 categ;
               } anyobj;
typedef struct typeobj { /* description of a type */
  uns8 categ;
  typedescr type;
               } typeobj;
typedef struct { /* description of a cursor or a table */
  uns8 categ;
  code_addr offset;  /* this is code offset! */
  tobjnum defnum;
  typeobj * type;
               } cursobj;
typedef struct { /* description of a constant */
  uns8 categ;
  basicval0 value;
  typeobj * type;
               } constobj;
typedef struct { /* description of a variable, parameter, recelem */
  uns8 categ;
  typeobj * type;
  unsigned offset;
  uns8 ordr;
  wbbool multielem;   /* used only in cursor describing records */
               } varobj;
typedef struct { /* description of a user-defined subroutine */
  uns8 categ;
  code_addr code;
  unsigned localsize;
  struct objtable * locals;
  typeobj * retvaltype;
  uns16 saved_ordr;
               } subrobj;
typedef struct {
  uns8 categ;
  uns8 dtype;
               } spar;
typedef struct { /* description of a standard procedure/function */
  uns8 categ;
  uns16 sprocnum;
  uns16 localsize;  /* never is more for std. PF */
  spar * pars;
  uns8 retvaltype;  /* 0 iff no return value, cannot be composed */
               } procobj;
typedef struct {
  uns8 categ;
  uns8 ag_type;
               } aggrobj;
struct propobj
{ uns8 categ;
  uns16 method_number;
  uns8  dirtype;
};
struct methobj  // beginning is the same as for procobj
{ uns8 categ;
  uns16 sprocnum;
  uns16 localsize;  
  spar * pars;
  uns8 retvaltype;  /* 0 iff no return value, cannot be composed */
  char * pardescr;
};
struct t_ivcols  // like ctlg_attr_descr
{ char name[ATTRNAMELEN+1];
  uns8 type;
  uns8 specif;
  uns8 order;
};

struct infoviewobj
{ uns8 categ;
  uns16 ivnum;
  const t_ivcols * cols;
};

typedef union object {   /* various object categories */
  anyobj   any;
  constobj cons;
  typeobj  type;
  subrobj  subr;
  procobj  proc;
  varobj   var;
  cursobj  curs;
  aggrobj  aggr;
  propobj  prop;
  methobj  meth;
  infoviewobj iv;
              } object;
typedef struct objtable {   /* table of object names */
  struct objtable * next_table; /* ptr to the table on the higher level */
  short  objnum;
  short  tabsize;
  objdef objects[1];            /* an array of object definitions */
                        } objtable;

#define MAKE_TOBJ(x)	((typeobj*)(long)(x))
#define MAKE_OBJ(x)	  ((object *)(long)(x))
#define DIRECT(x)     (!(uns16)((DWORD)(void *)(x)>>16))
#define DIRTYPE(x)    (*(uns16*)&x)
#define ATT_TYPE(x)      (DIRTYPE(x) & 0x00ff)

#define END_OF_SOURCE_PART  1  /*  separator of source parts */
#define ORDER_BYTEMARK      1
#define QUERY_TEST_MARK     0xdc

CFNC DllKernel symbol WINAPI next_sym(CIp_t CI);
CFNC DllKernel void   WINAPI next_and_test(CIp_t CI, symbol sym, short message);
CFNC DllKernel void   WINAPI test_and_next(CIp_t CI, symbol sym, short message);

object * search_obj(CIp_t CI, ctptr name, uns8 * obj_level);

#define ATT_WINID ATT_INT32

#define S_SOURCE_END  0
#define S_IDENT       1
#define S_INTEGER     2
#define S_REAL        3
#define S_STRING      4
#define S_CHAR        5
#define S_DATE        6
#define S_TIME        7
#define S_MONEY       8
#define S_TIMESTAMP   9

#define S_LESS_OR_EQ 10
#define S_GR_OR_EQ   11
#define S_NOT_EQ     12
#define S_ASSIGN     13
#define S_DDOT       14
#define S_DBL_AT     15
#define S_PAGENUM    16
#define S_PREFIX     17
#define S_SUBSTR     18
#define S_CURRVIEW   19
#define S_NEXTEQU    20  
#define S_BINLIT     21
#define S_SQLSTRING  22
/* keywords will have their symbol numbers from 0x80 up */
enum keywords { S_AND=128, S_ARRAY, S_BEGIN, S_BINARY, S_CASE, S_CONST,
                S_CSISTRNG, S_CSSTRNG,
                S_CURSOR, S_DIV, S_DO, S_DOWNTO,
                S_ELSE, S_END, S_FILE, S_FOR, S_FORM, S_FUNCTION, S_HALT, S_IF,
                S_INCLUDE, S_MOD,
                S_NOT, S_OF, S_OR, S_PROCEDURE, S_RECORD,
                S_REPEAT, S_RETURN, S_STRNG, S_TABLE, S_THEN, S_THISFORM, S_TO, S_TYPE,
                S_UNTIL, S_VAR, S_WHILE, S_WITH };
enum { S_ADD=128, SQ_AFTER, S_ALL, S_ALTER, SQ_AND, SQ_ANY,
  S_AS, S_ASC, S_AUTHOR, S_AUTOR, S_AVG,
  SQ_BEFORE, SQ_BEGIN, S_BETWEEN, S_BIGINT, SQ_BINARY,
  S_BIPTR, S_BIT, SQ_BLOB, SQ_BOOLEAN, S_BY,
  SQ_CALL, S_CASCADE, SQ_CASE, SQ_CAST, SQ_CHAR, S_CHARACTER,
  S_CHECK, SQ_CLOB, SQ_CLOSE, SQ_COALESCE, S_COLLATE, SQ_COMMIT,
  SQ_CONCAT, SQ_CONDITION, SQ_CONSTANT, S_CONSTRAINT, SQ_CONTINUE,
  SQ_CORRESPONDING, S_COUNT, S_CREATE, SQ_CROSS, S_CURRENT, SQ_CURSOR,
  SQ_DATE, S_DATIM, S_DEC, S_DECIMAL, SQ_DECLARE, S_DEFAULT, S_DELETE,
  S_DESC, S_DISTINCT, SQ_DIV, SQ_DO, S_DOUBLE, S_DROP,
  SQ_ELSE, SQ_ELSEIF, SQ_END, SQ_ESCAPE, SQ_EXCEPT,
  S_EXISTS, SQ_EXIT, SQ_EXTERNAL, SQ_FETCH, S_FLOAT, SQ_FOR,
  S_FOREIGN, S_FROM, SQ_FULL, SQ_FUNCTION, S_GRANT, S_GROUP,
  SQ_HANDLER, S_HAVING, S_HISTORY,
  SQ_IF, SQ_IN, S_INDEX, SQ_INNER, SQ_INOUT, S_INSERT, S_INT,
  SQ_INTEGER, SQ_INTERS, S_INTO, S_IS, S_JOIN, S_KEY,
  SQ_LARGE, SQ_LEAVE, S_LEFT, SQ_LIKE, S_LONG, SQ_LOOP,
  S_MAX, S_MIN, SQ_MOD, S_NATIONAL, SQ_NATURAL, S_NCHAR, SQ_NOT,
  S_NULL, SQ_NULLIF, S_NUMERIC, SQ_OBJECT, 
  SQ_OF, S_ON, SQ_OPEN, SQ_OR, S_ORDER, SQ_OTHERS, SQ_OUT, S_OUTER,
  S_POINTER, S_PRECISION, S_PRIMARY, SQ_PROCEDURE, S_PUBLIC, SQ_REAL,
  SQ_REDO, S_REFERENCES, SQ_REFERENCING, SQ_RELEASE, SQ_REPEAT, SQ_RESIGNAL, S_RESTRICT,
  SQ_RETURN, SQ_RETURNS, S_REVOKE, S_RIGHT, SQ_ROLLBACK, SQ_SAVEPOINT,
  SQ_SCHEMA, S_SELECT, SQ_SEQUENCE, S_SET, SQ_SIGNAL, S_SIGNATURE, S_SMALLINT, SQ_SOME,
  SQ_SQLEXCEPTION, SQ_SQLSTATE, SQ_SQLWARNING, SQ_START, S_SUM,
  SQ_TABLE, SQ_THEN, SQ_TIME,
  SQ_TIMESTAMP, SQ_TO, SQ_TRIGGER, SQ_TUPLE, SQ_UNDO, S_UNION, S_UNIQUE,
  SQ_UNTIL, SQ_UPDATABLE, S_UPDATE, S_USER, SQ_USING,
  S_VALUES, S_VARBINARY, S_VARCHAR, S_VARYING,
  S_VIEW, SQ_WHEN, S_WHERE, SQ_WHILE, SQ_WITH };
// S_IS a SQ_IN fixed in winsezam.rc in RCDATA for query designer!

//////////////////////////// conversion functions //////////////////////////////
extern "C" {
DllKernel void WINAPI int16tostr(sig16 val, tptr txt);
DllKernel void WINAPI int32tostr(sig32 val, tptr txt);
DllKernel BOOL WINAPI str2uns(tptr * ptxt, uns32 * val);  /* without end-check */
DllKernel void WINAPI conv2str(basicval0 * bas, uns8 tp, tptr txt, sig8 prez);
DllKernel BOOL WINAPI strconv(uns8 tp, tptr txt, basicval0 * cell);
DllKernel void WINAPI money_neg (monstr * m);

DllKernel void  WINAPI encode     (char * tx, unsigned size, BOOL inputing, int recode);
}

BOOL same_type(unsigned t1, unsigned t2);

int  cmpmoney (monstr * m1, monstr * m2);
void moneymult(monstr * m1, sig32 val);
void moneyadd (monstr * m1, monstr * m2);
void moneysub (monstr * m1, monstr * m2);
void moneydiv (monstr * m1, monstr * m2);

BOOL sens_Pref  (tptr s1, tptr s2, uns8 tp);
BOOL sens_Substr(tptr s1, tptr s2, uns8 tp);

#define BAS_DATE_FORMATS      2
#define EXT_DATE_FORMATS      6
#define BAS_TIME_FORMATS      3
#define EXT_TIME_FORMATS      4
#define TIMESTAMP_FORMATS    18

#ifndef WINS
struct t_dircomm
{ int result;
  LONG request_semaphore;
  LONG answer_semaphore;
  request_frame * rq; 
  answer_cb ** answer;
};
#endif
//////////////////////////////////// server debugging //////////////////////////////////
#define DBGOP_GET_USER   1
#define DBGOP_GET_STATE  2
#define DBGOP_INIT       3
#define DBGOP_ADD_BP     4
#define DBGOP_REMOVE_BP  5
#define DBGOP_GO         6
#define DBGOP_STEP       7
#define DBGOP_TRACE      8
#define DBGOP_OUTER      9
#define DBGOP_GOTO       10
#define DBGOP_EVAL       11
#define DBGOP_CLOSE      12
#define DBGOP_STACK      13
#define DBGOP_ASSIGN     14

#define DBGSTATE_NOT_FOUND  0   // debugged process not found
#define DBGSTATE_BREAKED    1
#define DBGSTATE_EXECUTING  2
#define DBGSTATE_NO_REQUEST 3

struct t_stack_info
{ tobjnum objnum;
  uns32 line;
};

///////////////////////////// sequences ////////////////////////////////
typedef int t_seq_value;

struct t_sequence
{ cdp_t cdp;                  // used only when modifying from GUI
  tobjname object_folder;     // used only as a store on the server side
  BOOL modifying, recursive;  // used only when analysing SQL statement (controls recursive analysis of original sequence)
                              // modifying used by GUI too, controls the dialog 
  tobjname schema,            // used only when analysing SQL statement
           name;  
  tobjnum objnum;
  t_seq_value currval,        // used only on the server
    startval, step, maxval, minval;
  int cache;
  BOOL hasmax, hasmin, cycles, hascache, ordered;
};

void WINAPI sequence_anal(CIp_t CI);
BOOL compile_sequence(cdp_t cdp, tptr defin, t_sequence * seq);
tptr sequence_to_source(cdp_t cdp, t_sequence * seq, BOOL altering);
////////////////////////////// various defines ///////////////////////////////////
#ifdef UNIX
#define PATH_SEPARATOR     '/'
#define PATH_SEPARATOR_STR "/"
#else
#define PATH_SEPARATOR     '\\'
#define PATH_SEPARATOR_STR "\\"
typedef int socklen_t;   // on LINUX defined as unsigned
#endif

#define DEFAULT_IP_SOCKET 5001

CFNC DllKernel void WINAPI enc_buffer_total(cdp_t cdp, tptr buf, int size, tobjnum objnum);
#define CLIENT_SERVER_FILE_MAPPING_SIZE 1000000L

////////////////////////////// threading /////////////////////////////////
#ifdef WINS

typedef                   unsigned WINAPI THREAD_PROC_TYPE(void *);
#define THREAD_PROC(name) unsigned WINAPI             name(void * data)
#define THREAD_RETURN     return 0
typedef HANDLE THREAD_HANDLE;
#define THREAD_START_JOINABLE(a,b,c,d) THREAD_START(a,b,c,d)

#else
#ifdef UNIX ///////////////////

typedef                   void * THREAD_PROC_TYPE(void *);
#define THREAD_PROC(name) void *             name(void * data)
#define THREAD_RETURN     return NULL
typedef pthread_t THREAD_HANDLE;
BOOL THREAD_START_JOINABLE(THREAD_PROC_TYPE * name, unsigned stack_size, void * param, THREAD_HANDLE * handle);

#else // NLM /////////////////

CFNC int FAR _beginthread(void (FAR *start_address)(void FAR *), void FAR *stack_bottom, unsigned stack_size, void FAR *arglist);
CFNC void FAR _endthread(void);

typedef                   void THREAD_PROC_TYPE(void *);
#define THREAD_PROC(name) void             name(void * data)
#define THREAD_RETURN     _endthread()  // zpusobuje, ze alokace pameti v CLIB neroste s kazdym spustenim a ukoncenim threadu
typedef HANDLE THREAD_HANDLE;
#define THREAD_START_JOINABLE(a,b,c,d) THREAD_START(a,b,c,d)

#endif
#endif ///////////////////////

BOOL THREAD_START(THREAD_PROC_TYPE * name, unsigned stack_size, void * param, THREAD_HANDLE * handle);
