#ifndef WINDOWS_REPLAC
#define WINDOWS_REPLAC

#ifdef __WATCOMC__
#pragma off (unreferenced)
#endif

#ifdef UNIX
#pragma pack(1)
#endif

#define FAR
#define EXPORT
typedef int BOOL;
#ifndef TRUE
#define TRUE  1
#endif
#ifndef FALSE
#define FALSE 0
#endif
typedef unsigned HANDLE;
typedef unsigned HINSTANCE;
typedef unsigned HMETAFILE;
typedef unsigned HGLOBAL;
#ifdef UNIX
#define CALLBACK 
#define WINAPI   
#else
#define CALLBACK _stdcall
#define WINAPI   _stdcall
#endif
typedef void (WINAPI * FARPROC)(void); // used for procedures from externl DLLs/NLMs

#include <setjmp.h>
typedef jmp_buf CATCHBUF;
#define Catch(x) setjmp(x)
#define MyThrow(x,y) longjmp(x,y)

#define hmemcpy(hpvDest, hpvSource, cbCopy) memcpy(hpvDest, hpvSource, cbCopy)
#define wsprintf 			    sprintf

#define __huge
#define _fastcall
#define __fastcall

#ifndef WORD
typedef unsigned short WORD;
#endif
#ifndef BYTE
typedef unsigned char BYTE, * LPBYTE;
#endif
#ifndef byte
typedef unsigned char byte;
#endif
typedef WORD * LPWORD;
typedef void * LPVOID;
typedef const void * LPCVOID;
#ifndef LONG
typedef long LONG;
#endif
typedef long * LPLONG;
typedef unsigned UINT;
typedef unsigned long DWORD;
typedef DWORD * LPDWORD;
typedef void VOID;
typedef unsigned short * LPWSTR;
#ifndef MAX_PATH
#define MAX_PATH 260
#endif

#define LOWORD(l)           ((WORD)(DWORD)(l))
#define HIWORD(l)           ((WORD)((((DWORD)(l)) >> 16) & 0xFFFF))
#define SELECTOROF(lp)      HIWORD(lp)
#define OFFSETOF(lp)        LOWORD(lp)
#define MAKELP(sel, off)    ((void FAR*)MAKELONG((off), (sel)))
#define MAKELONG(low, high) ((LONG)(((WORD)(low)) | (((DWORD)((WORD)(high))) << 16)))

typedef unsigned HWND;
typedef unsigned HTASK;
typedef unsigned HINST;
typedef unsigned HICON;
typedef unsigned HFONT;
typedef unsigned HBRUSH;
typedef unsigned HPALETTE;
typedef unsigned HDC;
typedef unsigned HCURSOR;
typedef unsigned HMENU;
typedef unsigned HBITMAP;
typedef unsigned WPARAM;
typedef unsigned long LPARAM;
typedef unsigned long LRESULT;
typedef char * LPSTR;
typedef char * LPTSTR;
typedef const char * LPCSTR;
typedef const char * LPCTSTR;
typedef UINT                ATOM;
typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);
typedef void SECURITY_ATTRIBUTES;

#define OF_READ 	    O_RDONLY
#define OF_WRITE	    O_WRONLY
#define OF_READWRITE	    O_RDWR
#define OF_SHARE_EXCLUSIVE  0x0000
#define OF_SHARE_DENY_NONE  0x0000
#define OF_SHARE_DENY_WRITE 0x0000
#define READ 	          O_RDONLY
#define WRITE     	    O_WRONLY
#define READ_WRITE	    O_RDWR

#define HFILE_ERROR  -1
typedef int HFILE;

#define sys_open(x,y)      open(x,y)
#define sys_creat(x)       creat(x,0)
#define sys_close(x)       close(x)
#define sys_read(x,y,z)    read(x,y,z)
#define sys_write(x,y,z)   write(x,y,z)
#define sys_lseek(x,y,z)   lseek(x,y,z)
#define _lopen(x,y)      open(x,y)
#define _lcreat(x,y)     creat(x,y)
#define _lclose(x)       ::close(x)
#define _lread(x,y,z)    read(x,y,z)
#define _lwrite(x,y,z)   write(x,y,z)
#define _llseek(x,y,z)   lseek(x,y,z)

#define LF_FACESIZE	    32
typedef struct tagLOGFONT
{
    int     lfHeight;
    int     lfWidth;
    int     lfEscapement;
    int     lfOrientation;
    int     lfWeight;
    BYTE    lfItalic;
    BYTE    lfUnderline;
    BYTE    lfStrikeOut;
    BYTE    lfCharSet;
    BYTE    lfOutPrecision;
    BYTE    lfClipPrecision;
    BYTE    lfQuality;
    BYTE    lfPitchAndFamily;
    char    lfFaceName[LF_FACESIZE];
} LOGFONT;

typedef struct tagBITMAPFILEHEADER
{
    UINT    bfType;
    DWORD   bfSize;
    UINT    bfReserved1;
    UINT    bfReserved2;
    DWORD   bfOffBits;
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER
{
    DWORD   biSize;
    LONG    biWidth;
    LONG    biHeight;
    WORD    biPlanes;
    WORD    biBitCount;
    DWORD   biCompression;
    DWORD   biSizeImage;
    LONG    biXPelsPerMeter;
    LONG    biYPelsPerMeter;
    DWORD   biClrUsed;
    DWORD   biClrImportant;
} BITMAPINFOHEADER;

typedef struct tagRGBQUAD
{
    BYTE    rgbBlue;
    BYTE    rgbGreen;
    BYTE    rgbRed;
    BYTE    rgbReserved;
} RGBQUAD;

typedef struct tagRECT {    /* rc */
   int left;
   int top;
   int right;
   int bottom;
} RECT, *LPRECT;


typedef struct tagDRAWITEMSTRUCT {  /* ditm */
    UINT  CtlType;
    UINT  CtlID;
    UINT  itemID;
    UINT  itemAction;
    UINT  itemState;
    HWND  hwndItem;
    HDC   hDC;
    RECT  rcItem;
    DWORD itemData;
} DRAWITEMSTRUCT;

#define COLORREF LONG

typedef struct tagPOINT {   /* pt */
   int x;
   int y;
} POINT;

typedef struct tagMSG {     /* msg */
    HWND   hwnd;
    UINT   message;
    WPARAM wParam;
    LPARAM lParam;
    DWORD  time;
    POINT  pt;
} MSG, * LPMSG;

DWORD GetTickCount(void);  // replacement for NLM
typedef unsigned long ULONG;
typedef void * LPDEVMODE;
//////////////////////////////// Win32 file I/O /////////////////////////////////////////////
typedef void * LPOVERLAPPED;
typedef void * LPSECURITY_ATTRIBUTES;
#define INVALID_HANDLE_VALUE ((HANDLE)-1)
#define FILE_BEGIN   0
#define FILE_CURRENT 1
#define FILE_END     2
#define GENERIC_READ      (0x80000000L)
#define GENERIC_WRITE     (0x40000000L)
#define CREATE_ALWAYS       2
#define OPEN_EXISTING       3
#define OPEN_ALWAYS         4
#define FILE_ATTRIBUTE_NORMAL    0x00000080  
#define FILE_SHARE_READ         0 // not defined
#define FILE_SHARE_WRITE        0 // not defined
#define FILE_FLAG_RANDOM_ACCESS 0 // not defined
#define SetFilePointer(hnd,pos,hi,start) lseek(hnd,pos,start)
#define GetFileSize(hnd,hi)              lseek(hnd,0,2)

struct WIN32_FIND_DATA
{ char cFileName[256];
#ifdef UNIX
  char Pat[13];
  int  PatL;
#endif
};

extern "C" {
HANDLE WINAPI CreateFile(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, 
  LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, 
  DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);
BOOL   WINAPI CloseHandle(HANDLE hObject);
BOOL   WINAPI ReadFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead,
                          LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped);
BOOL   WINAPI WriteFile(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite,
             LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped);

BOOL WINAPI MoveFile(LPCTSTR lpExistingFileName, LPCTSTR lpNewFileName);
BOOL WINAPI CopyFile(LPCTSTR lpExistingFileName, LPCTSTR lpNewFileName, BOOL bFailIfExists);
BOOL WINAPI DeleteFile(LPCTSTR lpFileName);
BOOL WINAPI CreateDirectory(LPCTSTR lpPathName, LPSECURITY_ATTRIBUTES lpSecurityAttributes);
UINT WINAPI GetTempFileName(LPCTSTR lpPathName, LPCTSTR lpPrefixString, UINT uUnique, LPTSTR lpTempFileName);

typedef WIN32_FIND_DATA * LPWIN32_FIND_DATA;
HANDLE FindFirstFile(LPCTSTR lpFileName, LPWIN32_FIND_DATA lpFindFileData);
BOOL FindNextFile(HANDLE hFindFile, LPWIN32_FIND_DATA lpFindFileData);
BOOL FindClose(HANDLE hFindFile);
}
/////////////////////////////////// synchronization ///////////////////////////////////////////
#ifdef UNIX
#include <pthread.h>
typedef pthread_mutex_t CRITICAL_SECTION;
struct Semaph
{ pthread_cond_t  cond;
  pthread_mutex_t mutex;
  int sem_count;
};
typedef Semaph LocEvent;

#else // NLM

struct CRITICAL_SECTION
{ int thread_id; // ... of the thread inside, 0 otherwise
  int count;     // number of additional entries on the thread inside
  LONG hSemaph;
};
typedef LONG Semaph;
typedef LONG LocEvent;

#endif


void InitializeCriticalSection(CRITICAL_SECTION * cs);
void DeleteCriticalSection    (CRITICAL_SECTION * cs);
void EnterCriticalSection     (CRITICAL_SECTION * cs);
void LeaveCriticalSection     (CRITICAL_SECTION * cs);
BOOL CheckCriticalSection     (CRITICAL_SECTION * cs);

#define INFINITE            0xFFFFFFFF  // Infinite timeout
#define WAIT_OBJECT_0       0x00000000L
#define WAIT_ABANDONED      0x00000080L 
#define WAIT_TIMEOUT        0x00000102L

extern "C" {
BOOL  WINAPI CreateLocalAutoEvent(BOOL bInitialState, LocEvent * event);
BOOL  WINAPI CloseLocalAutoEvent (LocEvent * event);
BOOL  WINAPI SetLocalAutoEvent   (LocEvent * event);
DWORD WINAPI WaitLocalAutoEvent  (LocEvent * event, DWORD timeout);

BOOL  WINAPI CreateSemaph(long lInitialCount, long lMaximumCount, Semaph * semaph);
BOOL  WINAPI CloseSemaph(Semaph * semaph);
BOOL  WINAPI ReleaseSemaph(Semaph * semaph, long count);
DWORD WINAPI WaitSemaph(Semaph * semaph, DWORD timeout);
}
#endif
////////////////////////////////////// timing ////////////////////////////////////////
#ifdef UNIX
void Sleep(unsigned long miliseconds);
#else
#define Sleep(x) delay(x)
#endif
///////////////////////////////////// profile ////////////////////////////////////////
int WINAPI GetPrivateProfileString(LPCSTR lpszSection,  LPCSTR lpszEntry,  LPCSTR lpszDefault,
            LPSTR lpszReturnBuffer, int cbReturnBuffer, LPCSTR lpszFilename);
UINT WINAPI GetPrivateProfileInt(LPCSTR lpszSection,  LPCSTR lpszEntry,  int defaultval, LPCSTR lpszFilename);
BOOL WINAPI WritePrivateProfileString(LPCSTR lpszSection,  LPCSTR lpszEntry, LPCSTR lpszString, LPCSTR lpszFilename);

////////////////////////////////////// UNIX specifics ///////////////////////////////////////////
#ifdef UNIX
typedef int Widget;
#define stricmp(a,b)      strcasecmp(a,b)
#define strnicmp(a,b,c)   strncasecmp(a,b,c)
int memicmp(const void *buf1, const void *buf2, unsigned int count);
#define O_BINARY 0  // not used in UNIX
#endif

